function [Lt,tch]=combine_pbn(mod1,mod2,ilyr,ds,ft,typ)
% ft = parition = (0, 1, 2) = (train, valid, test)
% typ = 'jout','cout'
% mod1 = pbn-c model
% mod2 = dnn model
% example: combine_pbn('tut3','tut2',3, 'mn389_0', 2, 'jout');
nc=length(ds);

% read in the dnn model
fn=[mod2 '_' ds  '_' ds '_out' num2str(ft) '.mat'];
fprintf('loading %s\n',fn);
p=load(fn);
eval(['hdnn=p.h' num2str(ilyr) ';']);
%hdnn=p.Zout;
[ns,nc]=size(hdnn);

Lt=[];
for i=1:nc,
      fn=[mod1 '_' ds  '_c' num2str(i) '_' ds '_' typ num2str(ft) '.mat'];
      fprintf('loading %s\n',fn);
      p=load(fn);
      if strcmp(typ,'cout'),
         L=p.c_out(:);
      else,
         L=p.l_out(:);
      end;
      Lt=[Lt L];
end;
tch=p.y;
tch(find(tch>0))=1;
tch(find(tch<0))=0;
ne=count_err(Lt',tch');
fprintf('n_err=%d, of %d = %f percent\n',ne, ns, ne/size(Lt,1)*100);

%hdnn=unlogist(eps+hdnn*(1-2*eps));
as=exp([log(.000001):.1:log(1000)]);na=length(as);
for ia=1:na,ne(ia)=count_err(hdnn'+Lt'*as(ia),tch'); end; 
fprintf('Min error %d of %d, %f percent\n',min(ne),ns, min(ne)/ns*100)
semilogx(as,ne/ns*100,'ro-');
set(gca,'fontsize',16);
text(as(1),ne(1)/ns*100,'FWD')
text(as(end),ne(end)/ns*100,'PBN')
xlabel('Combination factor');
ylabel('Validaition Error(percent)');
grid on
return
