function res=syn_grid(task, fn, lyr, nc, dim)
% syn_grid('overlap','unsup3_ds212223_out', lyr, nc, dim/idx);
%   requires both '..._out0.mat' and '..._out2.mat'
% syn_grid('viewfeat',fn, lyr, nc, dim/idx);
%   e.g.  $ syn_grid('viewfeat','unsup3_ds212223_out.mat', 2,3,2)
% syn_grid('genfeat',bs,mu,stdv)
%    e.g. $ syn_grid('genfeat',100,[2,4.4], [1,1]);
% syn_grid('view',fn,bs)
% eg: syn_grid('view','unsup3_ds212223_syn.mat',100);      
switch(task),
  case 'viewfeat',
      go3(0,fn,lyr, nc, dim);
      return
  case 'genfeat',
      %saveas(gcf, 'unsup3_ds313233_vae.fig', 'fig')
      bs=fn;
      mu=lyr;
      stdv=nc;
      dx=2/sqrt(bs);
      [z1,z2]=meshgrid([-1:dx:.99]*stdv(1)+mu(1),[-1:dx:.99]*stdv(2)+mu(2));  
      zin=[z1(:) z2(:)]';
      fprintf('zin has dimension %d by %d\n',size(zin,1),size(zin,2));
      save zin.mat zin                             
      return

  case 'view',
       bs=lyr;
       p=load(fn);
       m1=round(sqrt(bs));
       if isfield(p,'hp'),
          hp=p.hp;
       else,
          hp=p.x_out;
       end;
       H=[]; 
       for i=1:bs, 
             x = reshape(hp(i,:),14,14);
             H=multi_img(fliplr(x'),14,14,m1,m1,i,H); 
       end;   
       imagesc(flipud(logist(H)'));                           
      return
  case 'overlap',
      p0=load([fn '0.mat']);
      p2=load([fn '2.mat']);
      if isfield(p0,'lam'),
         Z_train=p0.lam;
         Z_test=p2.lam;
         if(0),
             fprintf('Making data class test from lambda\n')
             X=Z_train';
             X2=Z_test';
             s2=mean(X(:).^2);
             X=X/sqrt(s2);
             X2=X2/sqrt(s2);
             tch=p0.y';
             tch2=p2.y';
             nchan=1; N1=1; N2=size(X,1); nonlin=0; nclass=3;
             save('test.mat','X','X2','tch','tch2','nclass','nchan','N1','N2','nonlin');
         end;
      else,
         Z_train=p0.z;
         Z_test=p2.z;
      end;
      %eval(['Z=p.h' num2str(lyr) ';']);
      %plot3(Z(:,1),Z(:,2),Z(:,3),'.');
      %pause
      if(1),
           K=5;
           n=size(Z_test,1);
           nt=size(Z_train,1);
           ictt=zeros(n,1);
           [ym,icls]=max(p0.y,[],2);
           [ym,iclst]=max(p2.y,[],2);
           for i=1:n,
              z=Z_test(i,:);
              d=sum( (repmat(z,nt,1)-Z_train).^2,2);
              [d,is]=sort(d,'ascend');
              for k=1:nc,
                 ict(k)=sum(icls(is(1:K))==k);
              end;
              [lm,im]=max(ict(:));
              ictt(i)=im;
           end; 
           ne=sum(ictt ~= iclst);
           fprintf('ne=%d of %d, %f pct\n',ne,length(ictt),ne/length(ictt)*100);
           return
      end;
           
      NMODE=3; min_std=.05; idiag=0; ibias=1; nit=200;
      for ic=1:nc,
            fprintf('Estimating GMM for class %d\n',ic);
            ii=find(p0.y(:,ic)>0);
            z=Z_train(ii,:);
            [parm{ic},Q]=kmeans_init(z',NMODE,min_std,idiag,ibias,nit);
            fprintf('Computing LF on grid...\n',ic);
      end;
      fprintf('Computing overlap\n');
      ov=0;
      ovt=0;
      ne=0;
      nt=0;
      for ic=1:nc,
         ii=find(p2.y(:,ic)>0);
         z=Z_test(ii,:);
         lp0=lqr_evp(parm{ic},z',0);
         lm=max(lp0);
         p0=sum(exp(lp0-lm));
         L=[];
         for jc=1:nc,
            lpj=lqr_evp(parm{jc},z',0);
            L = [L lpj(:)];
         end;
         [lm,im]=max(L,[],2);
         ne=ne+sum(im ~= ic);
         nt=nt+length(im);
         E=exp(L-repmat(lm,1,nc));
         ls=sum(E,2);
         E=E./repmat(ls,1,nc);
         subplot(1,nc,ic); imagesc(E); colormap hot
         es=sum(E,1); 
         ovt=ovt+sum(es);
         es(ic)=0; 
         ov=ov+sum(es);
      end;
      fprintf('Ovlp=%f, ne=%d of %d, %f pct\n',ov/ovt, ne, nt, 100*ne/nt);
      res=100*ne/nt;
      return
end;

function p=go3(do_scp,fn,lyr,nc,dim)

%lyr=2;
%nc=2;
%dim=3;
%fn='unsup2_ds47_out.mat';
% go3(1,'unsup2_ds47_out.mat',2,2,3);
if do_scp,
   [s,l]=unix(['scp cuda:work/CSToolkit/MLP/' fn ' .']);                                        
end;
p=load(fn);
switch(nc),
   case 3,
      ii1=find(p.y(:,1)>0);
      ii2=find(p.y(:,2)>0); 
      ii3=find(p.y(:,3)>0);
   case 2,
      ii1=find(p.y(:,1)>0);
      ii2=find(p.y(:,2)>0); 
end;

%subplot(1,2,1+do_scp)
eval(['z=p.h' num2str(lyr) ';']);
%z=p.z;
if length(dim)~= 1,
      z=z(:,dim);
      dim=length(dim);
elseif dim ~= size(z,2),
      if(0),
         z2 = invert_nonlin(z(:),10);
         z=reshape(z2,size(z));
      end;
      fprintf('using PCA\n');
      R=z'*z;
      [U,D]=eig(R);
      D=diag(D);
      [D,is]=sort(D,'descend');
      z = z * U(:,is(1:dim));
end;

switch(dim),
case 3,
   if nc==3,
      plot3(z(ii1,1),z(ii1,2),z(ii1,3),'b.',z(ii2,1),z(ii2,2),z(ii2,3),'r.', z(ii3,1),z(ii3,2),z(ii3,3),'g+'); 
      %axis([0 1 0 1 0 1]);
   elseif nc==2,
      plot3(z(ii1,1),z(ii1,2),z(ii1,3),'b.',z(ii2,1),z(ii2,2),z(ii2,3),'r.'); 
      %axis([0 1 0 1 0 1]);
   else,
      plot3(z(:,1),z(:,2),z(:,3),'b.');
   end;
   view(3)
   %rotate3d
case 2,
   if nc==3,
      plot(z(ii1,1),z(ii1,2),'b.',z(ii2,1),z(ii2,2),'r.',z(ii3,1),z(ii3,2),'g+'); 
      %axis([0 1 0 1]);
   elseif nc==2,
      plot(z(ii1,1),z(ii1,2),'b.',z(ii2,1),z(ii2,2),'r.'); 
      %axis([0 1 0 1]);
   else,
      plot(z(:,1),z(:,2),'b.');
   end;
case 1,
   if nc==3,
      plot(z(ii1,1),z(ii1,2),'b.',z(ii2,1),z(ii2,2),'r.',z(ii3,1),z(ii3,2),'g+'); 
      %axis([0 1 0 1]);
   elseif nc==2,
      [nn,xx]=hist(z(ii1,1),50);
      [nn2,xx2]=hist(z(ii2,1),50);
      plot(xx,nn/(xx(2)-xx(1)),'r',xx2,nn2/(xx2(2)-xx2(1)),'b','linewidth',2)
      %axis([0 1 0 1]);
   else,
      plot(z(:,1),z(:,2),'b.');
   end;
end;
return



%function [F,e]=go3(id,iseed)
% id=1; iseed=12;
M=13;
usps2('cspca_init',M(1),iseed);
usps2('cspca_norm',M(1));
[e,L]=usps2('cspca_test',M(1));
f=.01; for i=1:300, e(i)=go('resL',id,'D',L*f); f=f*1.02; F(i)=f; end;
semilogx(F,e,'ro-','linewidth',2);
grid on

