import os
import numpy as np
from csf_defaults import cfg, data, AESARA

MAXLYR=8
MAXBRANCH=12

def set_defaults() :
    cfg.eval_data=0 # 0=train, 1=test, 2=valid
    cfg.use_crossent = 1
    cfg.one_event = 0 # set this to 1 if all events are the same size and an event is packed into one input
    cfg.c_avg = 0
    cfg.dropout = 0
    cfg.do_norm = 0
    cfg.labmaxpool = True
    cfg.show_lyr = 0
    cfg.show_brnch = 0
    cfg.lastc=0
    cfg.method='adam'
    cfg.fwd_s2 = 1
    cfg.batchsize = 1
    cfg.iepoch = 0
    cfg.lr = 1e-5
    cfg.l2_reg = 1e-5
    cfg.decay = 1.0
    cfg.dnn_is_running = False
    #cfg.train_class = 'valv2_mbnk1'
    cfg.train_class = 'fantc'
    cfg.train_fn = None
    #cfg.model = 'valv2'
    cfg.model = 'fan_tc'
    cfg.ibranch = 0
    cfg.nbranch = 0
    cfg.data_dir = './data'
    cfg.dnn_train_fn = None
    cfg.dnn_eval_fn = None
    cfg.verbosity = 0
    cfg.seed = 15

    print('Initializing random generator with seed ', cfg.seed)
    np.random.seed(cfg.seed)
    cfg.numpy_rng = np.random.RandomState(cfg.seed)
    if AESARA:
       from theano.tensor.random.utils import RandomStream as RandomStreams
       from theano.tensor.random.utils import RandomStream as RandomStreams2
    else:
       from theano.sandbox.rng_mrg import MRG_RandomStreams as RandomStreams
       from theano.tensor.shared_randomstreams import RandomStreams as RandomStreams2
    cfg.theano_rng = RandomStreams(cfg.numpy_rng.randint(2**30))

