from tkinter import *
from tkinter import font
import sys
import os
import time
import numpy as np
import scipy.io as scio
import theano
#import conv_utils
#import cpbn_utils
from ast import literal_eval
import matplotlib.pyplot as plt
if sys.version_info > (3, 0):
  import pickle as cPickle
  from past.builtins import xrange
else:
  import cPickle
import  gzip
import collections
from csf_utils import MAXDATACLASS,MAXMODELS,MAXLYR,NPARM
from csf_defaults import cfg,Object,data
from importlib import reload
import run_fns_csf as run_fns
if theano.config.device == 'cuda':
   import smegmagpu

from sys import platform
if platform[0:3] == "win" :
       font_size=12
       geom="900x300"
else:
       font_size=16
       geom="1050x355"

NONE_MOD  = 0
BLOCK_MOD = 1
HANN3_MOD = 2
FFTSQ_MOD = 3
AR_MOD    = 4
MELBNK_MOD= 5
layer_choices = [ 'none','block','hann3','fftsq','arx', 'lev', 'melbnk','sinar','c2r', 'rc', 'bilin', 'log', 'gmm', 'dct','sqrt']

cfg.lyrs=[None]*MAXLYR
for i in range(MAXLYR):
     cfg.lyrs[i] = Object()

cfg.models=[None]*MAXMODELS
for j in range(MAXMODELS):
   cfg.models[j] = Object()
   cfg.models[j].lyrs=[None]*MAXLYR
   for i in range(MAXLYR):
        cfg.models[j].lyrs[i] = Object()
        cfg.models[j].lyrs[i].prms = [None]*NPARM

cfg.isave = 0
cfg.iplot=0
cfg.batchsize = 32
cfg.max_segment_size = 768
cfg.fpbn_is_running = False
cfg.idata_set = 0
cfg.ievent = 0
cfg.verbosity = 0
cfg.imodel = 0
cfg.data_set = ['none']*MAXDATACLASS
cfg.model_name = ['none']*MAXMODELS
data_choices=['0','1','2','3','4','5','6','7','8','9',\
               '10','11','12','13','14','15','16','17','18','19',\
               '20','21','22','23','24','25']
model_choices=['0','1','2','3','4','5','6','7','8','9',\
               '10','11','12','13','14','15','16','17','18','19',\
               '20','21','22','23','24','25']

def set_parm(lyr,i,name,val):
    if lyr.prmstxt[i]["text"] != name:
       lyr.prmstxt[i]["text"] = name
       lyr.prms[i].delete(0, END);
       lyr.prms[i].insert(0, val);

def clr_parm(lyr,i):
      for k in range(i,NPARM):
        lyr.prms[k].delete(0, END);
        lyr.prmstxt[k]["text"] = ""

def action_button(frame,text, cmd, fgc = 'black', side=LEFT) :
     E7 = Button(frame, text=text, width=len(text)+1, command=cmd, fg=fgc,font=default_font)
     E7.pack(side=side)
     return E7

def label(frame, text, side=LEFT):
    L1 = Label(frame, width=int(len(text)*1.3),font=default_font)
    L1["text"] = text
    L1.pack( side = LEFT)
    return L1

def checkbox(frame, text,  cmd, side=LEFT, bg='lightgray'):
        var = IntVar() 
        fr8 = Checkbutton(frame, text=text, width=1+int(len(text)*1.0), variable=var, \
            command=cmd, bg=bg, font=default_font)
        fr8.pack(side=side)
        return var

def entry_field(frame, text,  initial_value, txt_width,  width, side=LEFT, bg='lightgrey',eside=LEFT):
        fr0 =  Frame(frame,  relief=RAISED, borderwidth=1)
        fr0a=Label(fr0, width=txt_width, height=1, text=text, bg=bg, font=default_font)
        fr0a.pack( side=eside) 
        sv = StringVar()
        fr0b = Entry(fr0, bd =1, width=width,textvariable=sv,font=default_font)
        fr0b.pack(side=eside)
        fr0b.delete(0, END)
        fr0b.insert(0, initial_value)
        fr0.pack(side = side)
        return fr0b, fr0a, sv

# runs epochs 'in background'
def scanning():
    if cfg.fpbn_is_running: 
        cfg.mode = 6
    # After 5 ms, call scanning again (create a recursive loop)
    root.after(5, scanning)

def update_cfg():
        cfg.verbosity = int(cfg.ivb_txt.get())
        cfg.ievent = int(cfg.iev_txt.get())
        #cfg.idata_set = int(cfg.idatavar.get())
        cfg.imodel = int(cfg.imodelvar.get())
        #cfg.data_set[cfg.idata_set]=cfg.data_txt.get()
        cfg.model_name[cfg.imodel]=cfg.model_txt.get()
        model_choices[cfg.imodel] = cfg.model_name[cfg.imodel]
        cfg.max_segment_size = int(cfg.max_seg_txt.get())
        cfg.nstd = float(cfg.nstd_txt.get())
        cfg.sample_rate = float(cfg.fs_txt.get())
        cfg.batchsize = int(cfg.bs_txt.get())

# clear_layers clears the GUI network section prior to loading a model
def clear_layers(*args):
   for i in range(MAXLYR):
       cfg.lyrs[i].type_var.set( 'none')
       for k in range(NPARM):
           cfg.lyrs[i].prmstxt[k]["text"] = ""
           cfg.lyrs[i].prms[k].delete(0, END)
   return

# fresh_layers will set default parameters when layer type is changes
def fresh_layers(*args):
   for i in range(MAXLYR):
       ilyrtyp = cfg.lyrs[i].type_var
       ilyrtyp_val = ilyrtyp.get()
       # first clear all params
       # Layer types with no parameters
       if ilyrtyp_val == 'none'  or ilyrtyp_val == 'fftsq' \
             or ilyrtyp_val == 'log' or ilyrtyp_val == 'rc' \
             or ilyrtyp_val == 'bilin' or ilyrtyp_val == 'dct' \
             or ilyrtyp_val == 'lev' or ilyrtyp_val == 'sqrt' \
             or ilyrtyp_val == 'c2r' :
          clr_parm(cfg.lyrs[i],0)
       elif ilyrtyp_val == 'block' :
           set_parm(cfg.lyrs[i],0,"N","384")
           set_parm(cfg.lyrs[i],1,"S","128")
           clr_parm(cfg.lyrs[i],2)
       elif ilyrtyp_val=='hann3':
           set_parm(cfg.lyrs[i],0,"N","384")
           clr_parm(cfg.lyrs[i],1)
       elif ilyrtyp_val == 'arx' : 
           set_parm(cfg.lyrs[i],0,"P","16")
           clr_parm(cfg.lyrs[i],1)
       elif ilyrtyp_val == 'gmm'  : 
           set_parm(cfg.lyrs[i],0,"M","8")
           set_parm(cfg.lyrs[i],1,"s",".3")
           clr_parm(cfg.lyrs[i],2)
       elif ilyrtyp_val == 'melbnk'  : 
           set_parm(cfg.lyrs[i],0,"K","16")
           set_parm(cfg.lyrs[i],1,"typ","0")
           clr_parm(cfg.lyrs[i],2)
       elif ilyrtyp_val == 'sinar'  : 
           set_parm(cfg.lyrs[i],0,"P","4")
           set_parm(cfg.lyrs[i],1,"k","2")
           set_parm(cfg.lyrs[i],2,"dc","0")
           clr_parm(cfg.lyrs[i],3)
   return

def updatelayers(*args):
   # here we update which one of the MAXMODELDATASET data sets is chosen
   cfg.imodel = int(cfg.imodelvar.get())
   #print('Set model number ', cfg.imodel, 'which is ', cfg.model_name[cfg.imodel])
   cfg.model_txt.delete(0, END)
   cfg.model_txt.insert(0, cfg.model_name[cfg.imodel])
   imod = cfg.imodel
   for i in range(MAXLYR):
        if hasattr(cfg.models[imod].lyrs[i],'layer_type') and not cfg.models[imod].lyrs[i].layer_type=='none':
           #print('Setting model type to ',  cfg.models[imod].lyrs[i].layer_type)
           cfg.lyrs[i].type_var.set( cfg.models[imod].lyrs[i].layer_type)
           for j in range(NPARM):
               if not cfg.models[imod].lyrs[i].prms[j] is None:
                   #print('Setting lyr', i, 'param ', j, 'type',  cfg.models[imod].lyrs[i].prms[j].name, \
                   #        'to' , cfg.models[imod].lyrs[i].prms[j].val)
                   cfg.lyrs[i].prmstxt[j]["text"] = cfg.models[imod].lyrs[i].prms[j].name
                   cfg.lyrs[i].prms[j].delete(0, END); 
                   cfg.lyrs[i].prms[j].insert(0, cfg.models[imod].lyrs[i].prms[j].val); 
                   #if not cfg.models[imod].lyrs[i].prms[j] is None \
                   #         and not cfg.models[imod].lyrs[i].prms[j].name == "":
                   #    print('Set param <', cfg.models[imod].lyrs[i].prms[j].name, '> to <',  \
                   #        cfg.models[imod].lyrs[i].prms[j].val, '>')
               else:
                   cfg.lyrs[i].prmstxt[j]["text"] = ""
                   cfg.lyrs[i].prms[j].delete(0, END); 
        else:
           cfg.models[imod].lyrs[i].layer_type = 'none'
           cfg.lyrs[i].type_var.set( cfg.models[imod].lyrs[i].layer_type)
   return

class Application(Frame):
    def chgsavstatus(self) :
        cfg.isave = self.savestate.get()

    def chgspastatus(self) :
        cfg.do_sp = self.spastate.get()

    def chgpltstatus(self) :
        cfg.iplot = self.pltstate.get()

    def play_snd(self):
        if platform[0:3] == "win" :
             import pygame.mixer
             #pygame.init()
             pygame.mixer.init()
             snd = pygame.mixer.Sound("snd_org.wav")
             #VOLUME=.2
             #snd.set_volume(VOLUME)
             snd.play()

             #from playsound import playsound
             #playsound('snd_org.wav')

             #import winsound
             #winsound.PlaySound('snd_org.wav', winsound.SND_FILENAME)

             #import simpleaudio as sa
             #wave_obj = sa.WaveObject.from_wave_file('snd_org.wav')
             #play_obj = wave_obj.play()
             #play_obj.wait_done()  # Wait until sound has finished playing
        else:
             os.system('play snd_org.wav > /dev/null  2> /dev/null')
    def play_snd_syn(self):
        if platform[0:3] == "win" :
             import pygame.mixer
             pygame.mixer.init()
             snd = pygame.mixer.Sound("snd_syn.wav")
             #VOLUME=.2
             #snd.set_volume(VOLUME)
             snd.play()
             #from playsound import playsound
             #playsound('snd_syn.wav')
             #import winsound
             #winsound.PlaySound('snd_syn.wav', winsound.SND_FILENAME)
             #import simpleaudio as sa
             #wave_obj = sa.WaveObject.from_wave_file('snd_syn.wav')
             #play_obj = wave_obj.play()
             #play_obj.wait_done()  # Wait until sound has finished playing
        else:
             os.system('play snd_syn.wav > /dev/null 2> /dev/null ')

    def load_data(self):
         update_cfg()
         cfg.data_set[cfg.idata_set]=cfg.data_txt.get()
         nev = run_fns.load_data()
         cfg.n_ev_txt.delete(0, END)
         cfg.n_ev_txt.insert(0, str(nev))
         cfg.fs_txt.delete(0, END)
         cfg.fs_txt.insert(0, str(cfg.sample_rate))

    def save_model(self):
         update_cfg()
         run_fns.save_model(cfg.imodel)

    def load_model(self):
         update_cfg()
         clear_layers()
         run_fns.load_model(cfg.imodel)
         updatelayers()

    def reload_modules(self):
       update_cfg()
       reload(run_fns)
       #reload(conv_utils)
       #reload(cpbn_utils)
       if theano.config.device == 'cuda':
          reload(smegmagpu)

    def updatedataset(*args):
        update_cfg()
        # here we update which one of the MAXDATASET data sets is chosen
        cfg.idata_set = int(cfg.idatavar.get())
        #cfg.data_set[cfg.idata_set]=cfg.data_txt.get()
        ds = cfg.data_set[cfg.idata_set]
        #print('Set data set number ', cfg.idata_set, 'which is ', cfg.data_set[cfg.idata_set])
        cfg.data_txt.delete(0, END)
        cfg.data_txt.insert(0, ds)

    def updatedatasetname(*args):
        if False:
           cfg.data_set_entry=cfg.data_sv.get()
        else:
           ds = cfg.data_txt.get()
        cfg.data_set[cfg.idata_set]=ds

    def calc_feats(*args):
        update_cfg()
        if not hasattr(cfg,'feat_fn') or cfg.feat_fn[cfg.imodel] is None:
            print('did you forget to compile the chain?')
            return
        run_fns.calc_feats(cfg.idata_set, cfg.imodel)

    def synth_feats(*args):
        update_cfg()
        if not hasattr(cfg,'feat_fn') or cfg.feat_fn[cfg.imodel] is None:
            print('did you forget to compile the chain?')
            return
        shft = int(cfg.syn_shf_txt.get())
        wl = int(cfg.syn_wl_txt.get())
        fn = cfg.syn_fn_txt.get().strip()
        run_fns.synth_feats(cfg.idata_set, cfg.imodel, fn, wl,shft)

    def compilemodel(*args):
        update_cfg()
        print('compiling model...')
        run_fns.compile_model()
        run_fns.compile_syn_model()
        print('done')


    def updatemodel(*args):
        update_cfg()
        # Transfer from GUI to model [cfg.imodel] parameters
        for i in range(MAXLYR):
            ilyrtyp = cfg.lyrs[i].type_var
            ilyrtyp_val = ilyrtyp.get()
            cfg.models[cfg.imodel].lyrs[i].layer_type = ilyrtyp_val
            for k in range(NPARM):
               if not cfg.lyrs[i].prms[k] is None:
                  fld = cfg.lyrs[i].prms[k]
                  txt = cfg.lyrs[i].prmstxt[k]
                  if cfg.models[cfg.imodel].lyrs[i].prms[k] is None:
                      cfg.models[cfg.imodel].lyrs[i].prms[k] = Object()
                  cfg.models[cfg.imodel].lyrs[i].prms[k].name = txt["text"]
                  cfg.models[cfg.imodel].lyrs[i].prms[k].val = fld.get()
               else:
                  cfg.models[cfg.imodel].lyrs[i].prms = None

    def fpbn_chgstatus(self):
       st= self.runstate.get()
       if st==1:
          if cfg.fpbn_is_running is False:
             cfg.fpbn_is_running = True
       else:
             cfg.fpbn_is_running = False 

    def createWidgets(self):

        # DATA Section
        frame0 = Frame(self, relief=RAISED, borderwidth=1)
        frame0.pack(fill=BOTH, expand=True)
        label(frame0, "DATA:  ", side=LEFT) # spacer
        cfg.idatavar=IntVar()
        cfg.idatavar.set(0)
        frame0x = Frame(frame0, relief=RAISED, borderwidth=1)
        dmen=OptionMenu(frame0x, cfg.idatavar, *data_choices)
        menu = self.nametowidget(dmen.menuname)
        menu.config(font=default_font) # changes menu font
        cfg.idatavar.trace('w', self.updatedataset)
        dmen.pack(side=None)
        if False:
          cfg.data_txt,_,cfg.data_sv=entry_field(frame0x, "", cfg.data_set[cfg.idata_set], 1, 10, side=None)
          cfg.data_sv.trace("w", self.updatedatasetname)
        else:
          cfg.data_txt,_,_=entry_field(frame0x, "", cfg.data_set[cfg.idata_set], 1, 10, side=None)
          cfg.data_txt.bind('<Return>',self.updatedatasetname)
        cfg.data_txt.config(font=default_font)
        frame0x.pack(side=LEFT)
        frame0y = Frame(frame0, relief=RAISED, borderwidth=1)
        action_button(frame0y,"SCAN", self.load_data, "black", side=None)
        cfg.n_ev_txt,_,_=entry_field(frame0y, "Nev", "0", 4, 5, side=None)
        cfg.n_ev_txt.config(font=default_font)
        frame0y.pack(side=LEFT)
        frame0z = Frame(frame0, relief=RAISED, borderwidth=1)
        cfg.max_seg_txt,_,_=entry_field(frame0z, "MaxSeg", str(cfg.max_segment_size), 7, 5, side=None)
        cfg.max_seg_txt.config(font=default_font)
        cfg.bs_txt,_,_=entry_field(frame0z, "BS", str(cfg.batchsize), 3, 5, side=None)
        cfg.bs_txt.config(font=default_font)
        frame0z.pack(side=LEFT)

        cfg.nstd_txt,_,_=entry_field(frame0, "N.Stdv", str(cfg.nstd), 7, 7, eside=None, side=LEFT)
        cfg.fs_txt,_,_=entry_field(frame0, "F.Samp", str(cfg.sample_rate), 7, 7, eside=None, side=LEFT)

        frame0a = Frame(frame0, relief=RAISED, borderwidth=1)
        action_button(frame0a,"QUIT", self.quit, "red", side=None)
        action_button(frame0a,"Reload", self.reload_modules, side=None)
        frame0a.pack(side=RIGHT)


        frame0c = Frame(frame0, relief=RAISED, borderwidth=1)
        self.savestate =checkbox(frame0c, "Write", self.chgsavstatus, side=None)
        self.savestate.set(0)
        self.pltstate =checkbox(frame0c, "Plot", self.chgpltstatus, side=None)
        self.pltstate.set(0)
        frame0c.pack(side=RIGHT)

        frame0b = Frame(frame0, relief=RAISED, borderwidth=1)
        cfg.ivb_txt,_,_=entry_field(frame0b, "verb.", str(cfg.verbosity), 5, 3, side=None)
        cfg.ivb_txt.config(font=default_font)
        cfg.iev_txt,_,_=entry_field(frame0b, "ev.", str(cfg.ievent), 3, 5, side=None)
        cfg.iev_txt.config(font=default_font)
        frame0b.pack(side=RIGHT)

        # Model Section
        frame1 = Frame(self, relief=RAISED, borderwidth=1)
        frame1.pack(fill=BOTH, expand=True)
        label(frame1, "MODEL: ", side=LEFT) # spacer
        cfg.imodelvar=IntVar()
        cfg.imodelvar.set(0)
        mmen=OptionMenu(frame1, cfg.imodelvar, *model_choices)
        mmen.config(font=default_font) # changes just butto font
        menu = self.nametowidget(mmen.menuname)
        menu.config(font=default_font) # changes just menu font

        cfg.imodelvar.trace('w', updatelayers)
        mmen.pack(side=LEFT)
        #cfg.model_txt,_=entry_field(frame1, "name", cfg.model_name[cfg.imodel], 5, 10, side=LEFT)
        # PMB: should this be cfg.model_name[0] ???
        cfg.model_txt,_,_=entry_field(frame1, "name", cfg.model_name[0], 5, 10, side=LEFT)
        cfg.model_txt.config(font=default_font)
        action_button(frame1,"LOAD", self.load_model, "black", side=LEFT)
        action_button(frame1,"SAVE", self.save_model, "black", side=LEFT)

        # NETWORK FRAME
        frame2 = Frame(self, relief=RAISED, borderwidth=1)
        frame2.pack(fill=BOTH, expand=True)
        self.lyrfrm= [None]*MAXLYR
        for i in range(MAXLYR):
            frt = Frame(frame2,  relief=RAISED, borderwidth=1)
            modstr=StringVar()
            modstr.set('none') # set the default option
            cfg.lyrs[i].type_var=modstr
            popupMenu = OptionMenu(frt, modstr, *layer_choices)
            menu = self.nametowidget(popupMenu.menuname)
            menu.config(font=default_font) # changes menu font
            modstr.trace('w', fresh_layers) 
            popupMenu.pack()
            cfg.lyrs[i].prms=[None]*NPARM
            cfg.lyrs[i].prmstxt=[None]*NPARM
            for j in range(NPARM):
                cfg.lyrs[i].prms[j],cfg.lyrs[i].prmstxt[j],_=entry_field(frt, "", "", 3,5,  side=None)
                cfg.lyrs[i].prms[j].config(font=default_font)
                cfg.lyrs[i].prmstxt[j].config(font=default_font)
            frt.pack(side=LEFT)
            #label(frame2, " ", side=LEFT) # spacer

        frame2a = Frame(frame2, relief=RAISED, borderwidth=1)
        action_button(frame2a,"APPLY", self.updatemodel,side=None)
        action_button(frame2a,"COMP", self.compilemodel,side=None)
        self.spastate =checkbox(frame2a, "SPA", self.chgspastatus, side=None)
        self.spastate.set(cfg.do_sp)
        frame2a.pack(side=LEFT)


        # FEATURE CALC FRAME
        frame3 = Frame(self, relief=RAISED, borderwidth=1)
        frame3.pack(fill=BOTH, expand=True)
        label(frame3, "FEATS: ", side=LEFT) # spacer
        action_button(frame3,"CALC", self.calc_feats,side=LEFT)
        action_button(frame3,"PLAY", self.play_snd,side=LEFT)
        action_button(frame3,"PLAY SYN", self.play_snd_syn,side=LEFT)
        label(frame3, "   ", side=LEFT) # spacer

        frame4 = Frame(self, relief=RAISED, borderwidth=1)
        frame4.pack(fill=BOTH, expand=True)
        action_button(frame4,"SYN", self.synth_feats,side=LEFT)
        cfg.syn_fn_txt,_,_=entry_field(frame4, "File", '', 7, 20, side=LEFT)
        cfg.syn_fn_txt.config(font=default_font)
        cfg.syn_wl_txt,_,_=entry_field(frame4, "WL", '', 5, 7, side=LEFT)
        cfg.syn_wl_txt.config(font=default_font)
        cfg.syn_shf_txt,_,_=entry_field(frame4, "SHFT", '', 5, 7, side=LEFT)
        cfg.syn_shf_txt.config(font=default_font)


    def __init__(self, master=None):
        Frame.__init__(self, master)
        self.pack()
        self.createWidgets()
        self.is_playing = False

def scanplots():
    # allocate time to process plots in background
    root.after(1000, scanplots) # every half second
    run_fns.refresh_plots()

# executa a 1-line operation
def op_line(sl,lp):
     if sl[0]=='SCRIPT':
         if lp.nloop>0:
             if sl[1]=='ENDLOOP':
                 lp.loopsize=lp.iloop
                 nlp= lp.nloop
                 lp.nloop=0
                 for i in range(nlp):
                    for j in range(lp.loopsize):
                        slt= lp.sl_loop[j].copy()
                        for l in range(len(slt)):
                            loc=slt[l].find('LC+1')
                            if loc>-1:
                              slt[l]=slt[l][0:loc]+str(i+1)+slt[l][loc+4:]
                            else:
                              loc=slt[l].find('LC')
                              if loc>-1:
                                 slt[l]=slt[l][0:loc]+str(i)+slt[l][loc+2:]
                        op_line(slt,lp)
             else:
                lp.sl_loop[lp.iloop]=sl
                lp.iloop+=1
         elif sl[1]=='STARTLOOP':
             lp.nloop=int(sl[2])
             lp.iloop = 0
         elif sl[1]=='QUIT':
            quit()
         elif sl[1]=='SCANDATA':
            ds = sl[2]
            cfg.idata_set=0;
            cfg.data_set[cfg.idata_set]=ds
            nev = run_fns.load_data()
         elif sl[1]=='LOADMODEL':
            mod=sl[2]
            cfg.imodel=0
            cfg.model_name[cfg.imodel]=mod
            run_fns.load_model(cfg.imodel)
         elif sl[1]=='COMPILE':
            run_fns.compile_model()
            run_fns.compile_syn_model()
         elif sl[1]=='FEATS': # cannot use 'CALC' because it contains 'LC'
            run_fns.calc_feats(cfg.idata_set, cfg.imodel)
         elif sl[1]=='PARAM':
            if sl[2]=='Write':
               print('SETTING Write to ',sl[3])
               cfg.isave = int(sl[3])
            elif sl[2]=='BS':
               print('SETTING BS to ',sl[3])
               cfg.batchsize = int(sl[3])
            else:
               print('UNKNOWN PARAMETER:', sl[2])
         else:
            print('UNKNOWN COMMAND:', sl[1])
     else:
        # inactive command or comment
        pass


from csf_defaults import set_defaults,AESARA
set_defaults()

if AESARA:
   from aesara.sandbox.rng_mrg import MRG_RandomStream as RandomStreams
   from theano.tensor.random.utils import RandomStream as RandomStreams2
else:
   from theano.sandbox.rng_mrg import MRG_RandomStreams as RandomStreams
   from theano.tensor.shared_randomstreams import RandomStreams as RandomStreams2

cfg.numpy_rng = np.random
cfg.theano_rng = RandomStreams(cfg.numpy_rng.randint(2**30))

loop_parms=Object()
loop_parms.nloop=0        # number of times to loop
loop_parms.loopsize=0     # number of commands in the loop
loop_parms.iloop=0        # current command in the loop
loop_parms.sl_loop=[None]*1000

if len(sys.argv) >1:
    filename = fn=sys.argv[1]
    print('loading ', filename)
    with open(filename,"r") as fp:
         line = fp.readline()
         lyrcnt = 0
         while line:
             sl=line.split()
             op_line(sl,loop_parms)
             line = fp.readline()
         quit()
    print('could not open ', filename)
    quit()


root = Tk()
#tkSnack.initializeSnack(root)
#cfg.snd = tkSnack.Sound()
default_font = font.nametofont("TkDefaultFont")
default_font.configure(size=font_size)

root.title("CSF Toolkit (" + theano.config.device + '-' + theano.config.floatX + ')')
root.geometry(geom)
app = Application(master=root)
root.after(1000, scanning)  # After 1 second, start scanning for epoch processing
root.after(2000, scanplots)  # After 1 second, start scanning plots

app.mainloop()
root.destroy()
quit()

