from tkinter import *
from tkinter import font
import sys
import os
import time
import numpy as np
import scipy.io as scio
import theano
from ast import literal_eval
import matplotlib.pyplot as plt
import  run_fns 
import cpbn_utils 
root = Tk()
if sys.version_info > (3, 0):
  import pickle as cPickle
  from past.builtins import xrange
else:
  import cPickle
import  gzip
import collections
import data_sets
import conv_utils
from defaults import set_defaults, inits, cfg, data, AESARA
from importlib import reload
from sys import platform
if  platform[0:3] == "win" :
       font_size=12
       geom="900x660"
else:
       font_size=15
       geom="1070x660"
default_font = font.nametofont("TkDefaultFont")
default_font.configure(size=font_size)


MAXLYR=10
class Object:
    pass

def scriptlog(text):
   if cfg.verbosity > 0:
      print( 'SCRIPT '+text)

def load_model():
   # import the experiment definition
   mod = cfg.prefix

   for i in range(MAXLYR):
      if cfg.lyrs[i] is None:
         cfg.lyrs[i] = Object()
      cfg.lyrs[i].input_dropout_fac=0.0 # clear pesky input_dropout

   exec('import models.' + cfg.prefix + '; reload(models.' + mod + '); models.' + mod + '.make_network(cfg)')

   # convert dropout to shared variable
   for i in range(MAXLYR):
       do = cfg.lyrs[i].input_dropout_fac
       do = np.asarray(do).astype(theano.config.floatX)
       cfg.lyrs[i].input_dropout_fac = theano.shared(value = do, name = 'input_dropout_fac')
       #dof=cfg.lyrs[i].input_dropout_fac.get_value()
       #print('AFTER: LYR',i,'DO=',dof)
  
def action_button(frame,text, cmd, fgc = 'black', side=LEFT, wd=0, bg='lightgray', wraplength=None) :
     if wd==0:
         if wraplength is None:
            wd=len(text)
         else:
            wd=1
     E7 = Button(frame, text=text, width=wd, height=0, command=cmd, fg=fgc, bg=bg, wraplength=wraplength)
     E7.pack(side=side)
     return E7

def label(frame, text, side=LEFT,bg='lightgray'):
    L1 = Label(frame, width=int(len(text)*1.3),bg=bg)
    L1["text"] = text
    L1.pack( side = side)
    return L1

def checkbox(frame, text,  cmd, side=LEFT, bg='lightgray'):
        var = IntVar() 
        fr8 = Checkbutton(frame, text=text, width=1+int(len(text)*1.0+.001), variable=var, \
            command=cmd, bg=bg)
        fr8.pack(side=side)
        return var

def entry_field(frame, text,  initial_value, width,  side=LEFT, bg='lightgrey', eside=None):
        fr0 =  Frame(frame,  relief=RAISED, borderwidth=1)
        fr0a=Label(fr0, width=len(text)+1, height=1, text=text, bg=bg)
        fr0a.pack(side=eside) 
        fr0b = Entry(fr0, bd =1, width=width,font = default_font)
        fr0b.pack(side=eside)
        fr0b.delete(0, END)
        fr0b.insert(0, initial_value)
        fr0.pack(side = side)
        return fr0b, fr0a

def double_entry_field(frame, text,  initial_value1, initial_value2, width,  side=LEFT, bg='lightgrey'):
        fr0 =  Frame(frame,  relief=RAISED, borderwidth=1)
        fr0a=Label(fr0, width=width, height=1, text=text, bg=bg)
        fr0a.pack( ) 
        fr0b = Entry(fr0, bd =1, width=width, font = default_font)
        fr0b.pack()
        fr0b.delete(0, END)
        fr0b.insert(0, initial_value1)
        fr0c = Entry(fr0, bd =1, width=width, font = default_font)
        fr0c.pack()
        fr0c.delete(0, END)
        fr0c.insert(0, initial_value2)
        upd_state=IntVar()
        fr0d = Checkbutton(fr0, variable=upd_state,  text="")
        fr0d.pack()
        ums_state=IntVar()
        fr0e = Checkbutton(fr0, variable=ums_state,  text="")
        fr0e.pack()
        fr0.pack(side = side)
        return fr0b, fr0a, fr0c,upd_state,ums_state

# runs epochs 'in background'

def scanning():
    use_aa = cfg.aadata
    if cfg.updn_is_running:
        try:
          if use_aa:
            run_fns.run_aa_data()
          run_fns.run_updn() 
        except Exception as e:
          print('updn failed', e)
    if cfg.fpbn_is_running: 
        try:
          if use_aa:
            run_fns.run_aa_data()
          run_fns.run_fpbn('train') 
        except Exception as e:
          print('fpbn failed', e)
    if cfg.spe_is_running:
        try:
          if use_aa:
            run_fns.run_aa_data()
          run_fns.run_sp_est() 
        except Exception as e:
          print('sp_est failed', e)
    if cfg.aec_is_running:
        try:
          if use_aa:
            run_fns.run_aa_data()
          run_fns.run_aec('train')
        except Exception as e:
          print('aec failed', e)
    if cfg.dnn_is_running:
        try:
          if use_aa:
            run_fns.run_aa_data()
          run_fns.run_dnn()
        except Exception as e:
          print('dnn failed', e)
    if cfg.gpbn_is_running:
        try:
          if use_aa:
            run_fns.run_aa_data()
          run_fns.run_fast_gpbn('train')
        except Exception as e:
          print('dpbn failed:', e)
    if cfg.csp_is_running:
        try:
          run_fns.run_csp() 
        except Exception as e:
          print('csp failed', e)

    # After 5 ms, call scanning again (create a recursive loop)
    root.after(5, scanning)
    cfg.scan_ctr = (cfg.scan_ctr +1)%10
    if cfg.scan_ctr==0:
         run_fns.refresh_plots()

class Application(Frame):
    def knn_chgstatus(self):
        cfg.use_knn = self.knn_runstate.get()
    def pltp_chgstatus(self):
        cfg.iplot_pbn = self.pp2.get()
    def dbnpbnsyn_chgstatus(self):
        cfg.dbnpbnsyn = self.dbncl.get()
    def rbmrnd_chgstatus(self):
        cfg.rbm_rnd = self.rbmrnd.get()
    def dbnrnd_chgstatus(self):
        cfg.dbn_rnd = self.dbnrnd.get()
    def rbmW_chgstatus(self):
        cfg.rbm_trainwts = self.rbmW.get()
    def us2i_chgstatus(self) : 
        cfg.update_s2_in = self.us2_in.get()
    def us2_chgstatus(self) : 
        cfg.update_s2 = self.us2.get()
    def fws2_chgstatus(self) : 
        cfg.fwd_s2 = self.fws2.get()
    def fss2_chgstatus(self) : 
        cfg.fast_s2 = self.fss2.get()
    def invnl_chgstatus(self) : 
        cfg.invert_NL = self.invnl.get()
    #def egy_chgstatus(self) : 
    #    cfg.use_egy = self.egy.get()
    def reconbias_chgstatus(self) : 
        cfg.use_recon_bias = self.rbstate.get()
    def reconwts_chgstatus(self) : 
        cfg.use_recon_wts = self.rwstate.get()
    def rnd_chgstatus(self) : 
        cfg.i_syn_rnd = self.rndcb.get()
    def rand_chgstatus(self) : 
        cfg.isrand = self.irandcb.get()
    def aadata_chgstatus(self) : 
        cfg.aadata = self.aacb.get()
    def gmmsv_chgstatus(self) : 
        cfg.save_gmm = self.gmmsv.get()
    def gmm_chgstatus(self) : 
        cfg.syn_use_gmm = self.gmmcb.get()
    def mxp_chgstatus(self) : 
        cfg.use_maxpool = self.mxpcb.get()
    def xent_chgstatus(self) : 
        cfg.UseCrossEntropy = self.xentcb.get()
    def synsrt_chgstatus(self) : 
        cfg.syn_sort_lik = self.synsrt.get()
    def usd_chgstatus(self) : 
        cfg.fpbn_use_dropout = self.usd.get()
    def swt_chgstatus(self) : 
        cfg.save_while_train = self.swt.get()
    def dcl_chgstatus(self) : 
        cfg.do_class = self.dcl.get()
    #def esd_chgstatus(self) : 
    #    cfg.exact_drv = self.exd.get()
    def chgsavstatus(self) : 
        cfg.isave = self.savestate.get()
    def chgdmp(self) : 
        cfg.enbl_pt = self.dmpstate.get()
    def chgpltstatus(self) : 
        cfg.iplot = self.plotstate.get()
    def chgVstatus(self) : 
        cfg.use_V = self.useVstate.get()
    def chgWstatus(self) : 
        cfg.update_W = self.useWstate.get()
    def drvtrn_chgstatus(self) : 
        cfg.drv_train = self.drvtrnstate.get()
    def update_cfg(self): 
        cfg.gmm_std=float(self.gmm_std_txt.get())
        igm = int(self.gmod_txt.get())
        # if nr of gmm modes changed, disable GMM for fwd fn
        if igm != cfg.gmm_mod and cfg.use_sigmoid == 3:
            cfg.use_sigmoid = 0
            self.sigmoid_state.set(0)
        cfg.gmm_mod = igm
        cfg.fpbn_crossent = float(self.crse_txt.get()) 
        #cfg.use_egy = self.egy.get()
        cfg.iplot = self.plotstate.get()
        cfg.ilayer=int(self.ilyr_txt.get())
        cfg.dpbn_ilyr=int(self.dpbn_ilyr_txt.get())
        cfg.n_syn=int(self.nsyn_txt.get())
        cfg.knn_k = int(self.knn_k_txt.get())
        cfg.vae_beta=float(self.vae_beta_txt.get())
        cfg.gmm_lyr = int(self.glyr_txt.get())
        cfg.C=float(self.clv_txt.get())
        cfg.aec_std=float(self.aec_std_txt.get()) 
        cfg.show_lyr = int(self.show_lyr_txt.get())
        #cfg.enbl_pt = self.dmpstate.get()
        cfg.batchsize=int(self.bs_txt.get())
        cfg.LABVAL=float(self.lv_txt.get())
        cfg.method=self.mthd_txt.get()
        cfg.decay=float(self.decay_txt.get()) 
        cfg.l2_reg=float(self.l2r_txt.get())
        #cfg.isrand=int(self.irand_txt.get())
        cfg.amin=float(self.amin_txt.get())
        cfg.verbosity=int(self.verb_txt.get())
        cfg.iclass_wt=int(self.iwt_txt.get())
        #cfg.windowlen=int(self.wl_txt.get()) # not settable!
        cfg.lpo_scale=float(self.lpo_txt.get())
        cfg.inshft=literal_eval(self.ishft_txt.get())
        if len(cfg.inshft) != 2:
            print('error: ishft needs 2 values')
            cfg.inshft=(0,0)
            self.ishft_txt.delete(0, END)
            self.ishft_txt.insert(0, "0,0")
        cfg.cshft=literal_eval(self.cshft_txt.get())
        if len(cfg.cshft) != 2:
            print('error: cshft needs 2 values, 0 or 1')
            cfg.cshft=(0,0)
            self.cshft_txt.delete(0, END)
            self.cshft_txt.insert(0, "0,0")
        cfg.lr=float(self.lr_txt.get())
        cfg.train_class=self.idata_txt.get()  
        idtr=str.split(self.idatat_txt.get(),",")
        cfg.test_class=idtr[0]
        if cfg.nonlin_in==0:
             cfg.minvar=float(self.minvar_txt.get())  
        else:
             cfg.minvar=0.0
        cfg.prefix= self.prefix_txt.get()
        cfg.use_sigmoid = self.sigmoid_state.get()
        #cfg.mod_type = self.modt_state.get()
        cfg.lbl_type = self.labt_state.get()
        cfg.eval_data = self.eval_data.get()
        cfg.dataset_type = self.dataset_type.get()
        #cfg.partition_train = self.partition_train.get()
        cfg.rbm_lyr=int(self.rlyr_txt.get())
        cfg.epochs=int(self.epoch_txt.get())
        cfg.dbn_nk = int(self.dbn_nk_txt.get())
        cfg.nit_sp_ng=int(self.nit_sp_txt.get())
        #cfg.sp_hist=int(self.his_sp_txt.get())
        cfg.drv_type = self.drv_state.get()
        # [FG]
        cfg.aa_n = int(self.aa_n_txt.get())
        cfg.aa_eps = float(self.aa_eps_txt.get())
        cfg.aa_target = int('-1' if self.aa_target_txt.get().strip() == '' else self.aa_target_txt.get().strip())

    def reload_modules(self):
       if cfg.iplot > 0:
           print('clearing plot history')
           cfg.ihist = cfg.histlen
           cfg.vihist = cfg.vhistlen
           #plt.close()
       self.update_cfg()
       cfg.updn_is_running=False 
       cfg.fpbn_is_running=False 
       cfg.spe_is_running=False 
       cfg.aec_is_running=False 
       cfg.dnn_is_running=False 
       cfg.gpbn_is_running=False 
       reload(run_fns)
       reload(cpbn_utils)
       reload(conv_utils)
       reload(data_sets)

    #def vae_chgstatus(self):
    #   cfg.use_vae= self.vaestate.get()

    def aec_chgstatus(self):
       st= self.aecrunstate.get()
       if st==1:
          if cfg.aadata:
               if cfg.fetch_aa_fn is None:
                   print("AA has to be compiled first")
                   return
               else:
                    print("Using new AA data for each epoch")
                    cfg.fetch_train_fn = cfg.fetch_aa_fn
          if cfg.aec_is_running is False:
             if cfg.vae_beta>0 :
                 print('start vae with nlayer=', cfg.nlayer)
             else:
                 print('start aec with nlayer=', cfg.nlayer)
             self.update_cfg()
             cfg.epochs=1
             cfg.aec_is_running = True
             cfg.iepoch = 0
       else:
             cfg.aec_is_running = False
             if self.eval_data.get() == 3:
                cfg.fetch_train_fn, _, _ = cpbn_utils.create_fetch_fns()


    def dnn_chgstatus(self):
       use_aa = cfg.aadata
       if use_aa:
           if cfg.fetch_aa_fn is None:
               print("AA data has to be created first")
               return
           else:
               print("Using new AA data for each epoch")
               cfg.fetch_train_fn = cfg.fetch_aa_fn
       st= self.dnnrunstate.get()
       if st==1:
          if cfg.dnn_is_running is False:
             self.update_cfg()
             cfg.epochs=1
             cfg.dnn_is_running = True
             cfg.iepoch = 0
             cfg.use_sigmoid = self.sigmoid_state.get()
       else:
            cfg.dnn_is_running = False
            if use_aa:
                cfg.fetch_train_fn, _, _ = cpbn_utils.create_fetch_fns()

    def csp_chgstatus(self):
       st= self.csp_runstate.get()
       if st==1:
          if cfg.csp_is_running is False:
             self.update_cfg()
             cfg.epochs=1
             cfg.csp_is_running = True
             cfg.iepoch = 0
       else:
            cfg.csp_is_running = False

    def updn_chgstatus(self):
       use_aa = cfg.aadata
       if use_aa:
            if cfg.fetch_aa_fn is None:
                print("AA data has to be created first")
                return
            else:
                print("Using new AA data for each epoch")
                cfg.fetch_train_fn = cfg.fetch_aa_fn
       st= self.updn_runstate.get()
       if st==1:
          if cfg.updn_is_running is False:
             self.update_cfg()
             cfg.epochs=1
             cfg.updn_is_running = True
             cfg.iepoch = 0
       else:
             cfg.updn_is_running = False
             if use_aa:
                 cfg.fetch_train_fn, _, _ = cpbn_utils.create_fetch_fns()

    def spe_chgstatus(self):
       if cfg.aadata:
            if cfg.fetch_aa_fn is None:
                print("AA has to be compiled first")
                return
            else:
                print("Using new AA data for each epoch")
                cfg.fetch_train_fn = cfg.fetch_aa_fn
       st= self.spe_runstate.get()
       if st==1:
          if cfg.spe_is_running is False:
             self.update_cfg()
             cfg.epochs=1
             cfg.spe_is_running = True
             cfg.iepoch = 0
       else:
             cfg.spe_is_running = False
             if self.eval_data.get() == 3:
                cfg.fetch_train_fn, _, _ = cpbn_utils.create_fetch_fns()

    def gpbn_chgstatus(self):
       if cfg.aadata:
            if cfg.fetch_aa_fn is None:
                print("AA has to be compiled first")
                return
            else:
                print("Using new AA data for each epoch")
                cfg.fetch_train_fn = cfg.fetch_aa_fn
       st= self.gpbnrunstate.get()
       if st==1:
          if cfg.gpbn_is_running is False:
             self.update_cfg()
             scriptlog('DPBNTRAIN  1')
             cfg.epochs=1
             cfg.gpbn_is_running = True
             cfg.iepoch = 0
       else:
             cfg.gpbn_is_running = False
             if self.eval_data.get() == 3:
                cfg.fetch_train_fn, _, _ = cpbn_utils.create_fetch_fns()

    def fpbn_chgstatus(self):
       if cfg.aadata:
            if cfg.fetch_aa_fn is None:
                print("AA has to be compiled first")
                return
            else:
                print("Using new AA data for each epoch")
                cfg.fetch_train_fn = cfg.fetch_aa_fn

       st= self.runstate.get()
       #print('status=', st)
       if st==1:
          if cfg.fpbn_is_running is False:
             # reload parameters that can be changed without re-computing graph
             self.update_cfg()
             scriptlog('PBNTRAIN  1')
             cfg.epochs=1
             cfg.fpbn_is_running = True
             cfg.iepoch = 0
       else:
             cfg.fpbn_is_running = False
             if self.eval_data.get() == 3:
                 cfg.fetch_train_fn, _, _ = cpbn_utils.create_fetch_fns()
             if cfg.do_profile:
                cfg.fpbn_train_fn.profile.summary()

    def loadmodel(self):
         self.update_cfg() 
         scriptlog('LOADMODEL '+cfg.prefix)
         load_model() 
         if hasattr(cfg.lyrs[0],'WL'):
              wl = cfg.lyrs[0].WL
              self.wl_txt.delete(0,END)
              self.wl_txt.insert(0,str(wl))
              print('setting window len to',wl)
              if cfg.windowlen != wl and cfg.dataset_type==2:
                  print('****IMPORTANT: WL changed to',wl, 'you need to re-load data and model')
              cfg.windowlen = wl
         conv_utils.init_network(  )  

         for i in range(MAXLYR):
               if i < cfg.nlayer:
                  if not hasattr(cfg.lyrs[i],'nonlin'):
                     print('incomplete model. Delete any incompatible xxx_lyr*.mat files and re-load data and model')
                     return
                  nl0=str(cfg.lyrs[i].nonlin[0])
                  nl1=str(cfg.lyrs[i].nonlin[1])
                  nl= str(nl0)+','+str(nl1)
                  if cfg.lyrs[i].type=='nl':
                     nc=cfg.lyrs[i].nnl
                  else:
                     nc=cfg.lyrs[i].nchan_out
                  typ=str(i)+':'+cfg.lyrs[i].type[0:2]+str(nc)
                  if hasattr(cfg.lyrs[i],'input_dropout_fac'):  
                      dof=cfg.lyrs[i].input_dropout_fac.get_value()
                      #print('Lyr', i, 'DO=', dof)
                      dof= "%5.3f" % dof.item()
                  else:
                      #print('Lyr', i, 'No DO=')
                      dof = "0"
                      conv_utils.add_shared(cfg.lyrs[i],'input_dropout_fac', np.zeros((),dtype=theano.config.floatX))
                  cfg.lyrs[i].update= True
                  cfg.lyrs[i].do_ums= False
               else:
                   nl = " "
                   typ = "  "
                   dof=" "
               self.lyrnl[i].delete(0,END)
               self.lyrnl[i].insert(0,nl)
               self.lyrdo[i].delete(0,END)
               self.lyrdo[i].insert(0,dof)
               self.lyrupd[i].set(1)
               self.lyrums[i].set(0)
               self.lyrtxt[i]["text"]=typ

    def savemodel(self):
         self.update_cfg()
         scriptlog('SAVEMODEL '+cfg.prefix)
         cpbn_utils.dump_parms(  )

    def delmodel(self):
         self.update_cfg()
         cpbn_utils.del_parms(  )

    def updatemodel(self):
         self.update_cfg()
         pfx = self.prefix_txt.get()
         print('updating model', self.prefix_txt.get() + '_' + cfg.train_class )
         cfg.prefix=pfx
         nlyr=0;
         for i in range(MAXLYR):
              nl_txt = self.lyrnl[i].get()
              nl_txt =nl_txt.replace(" ","") # remove white space
              try:
                 nl=literal_eval(nl_txt)
              except:
                 nl = (-1,-1)
              #print('got nl=', nl)
              if nl[0] >= 0:
                 cfg.lyrs[i].nonlin=( nl[0], nl[1])
                 dof = float(self.lyrdo[i].get())
                 dof=np.asarray(dof, dtype=theano.config.floatX).reshape(())
                 cfg.lyrs[i].input_dropout_fac.set_value(dof)
                 upd=self.lyrupd[i].get()
                 ums=self.lyrums[i].get()
                 if upd==1:
                      cfg.lyrs[i].update=True
                 else:
                      cfg.lyrs[i].update=False
                 if ums==1:
                      cfg.lyrs[i].do_ums=True
                 else:
                      cfg.lyrs[i].do_ums=False
                 if i< (cfg.nlayer-1):
                     cfg.lyrs[i+1].nonlin=( nl,  cfg.lyrs[i+1].nonlin[1])
                 nlyr=nlyr+1
              else:
                 break
         print('setting nlayer to ', nlyr)
         cfg.nlayer = nlyr
         #cfg.gmm_lyr = nlyr-1
         #self.glyr_txt.delete(0,END)
         #self.glyr_txt.insert(0,str(cfg.gmm_lyr))
        
    def show_wts(self):
        self.update_cfg()
        run_fns.dspl_wts()

    def pca_wts(self):
        self.update_cfg()
        run_fns.pca_wts('pca')

    def pca_zro(self):
        self.update_cfg()
        run_fns.pca_wts('zro')
       
    def pca_nrm(self):
        self.update_cfg()
        run_fns.pca_wts('nrm')

    def run_knn(self):
        self.update_cfg()
        run_fns.run_knn()
       
    def loaddata(self):
       #print('loading data ', self.E1.get())
       self.update_cfg()
       scriptlog('LOADDATA '+cfg.train_class)
       data_sets.load_data(cfg.train_class)
       self.minvar_txt.delete(0, END)
       self.minvar_txt.insert(0, str(cfg.minvar))
       self.idatat_txt.delete(0, END)
       self.idatat_txt.insert(0, cfg.train_class)
       if  not cfg.pp_fn is None:
             cfg.pp_fn.free()
       print('compiling pp_fn')
       cfg.pp_fn = cpbn_utils.create_pp_fn()


    def chg_param(self):
       print('chg param')

    def cspec_init(self): 
          if not cfg.csp_fn is None:
              cfg.csp_fn.free()
          cfg.csp_fn = cpbn_utils.create_csp()

    def sp_init(self): 
          if not cfg.spe_fn is None:
              cfg.spe_fn.free()
          print('Creating computation graphs .... ')
          cfg.spe_fn = cpbn_utils.create_sp_est()
          self.spint["fg"] = "green"
          print('Done creating graph')

    def dnn_init(self): 
          self.update_cfg()
          if cfg.inshft[0]+cfg.inshft[1]>0:
             print('compiling pp_fn')
             cfg.pp_fn.free()
             cfg.pp_fn = cpbn_utils.create_pp_fn()
          cfg.dnn_fn,cfg.dnn_eval_fn = cpbn_utils.create_dnn() 
          self.dnnb["fg"] = "green"
          print('Done creating graph')


    def aec_init(self): 
          self.update_cfg()
          if cfg.vae_beta > 0:
             print('init VAE with nlayer=', cfg.nlayer, ' beta=', cfg.vae_beta)
          else:
             print('init AEC with nlayer=', cfg.nlayer)
          conv_utils.init_sgd( )
          if cfg.inshft[0]+cfg.inshft[1]>0:
             print('compiling pp_fn')
             cfg.pp_fn.free()
             cfg.pp_fn = cpbn_utils.create_pp_fn()
          if cfg.vae_beta > 0:
             if not cfg.vae_train_fn is None:
                cfg.vae_train_fn.free(); cfg.vae_eval_fn.free(); 
             cfg.vae_train_fn,cfg.vae_eval_fn = cpbn_utils.create_pbn_vae() 
             cfg.aec_decod_fn = cpbn_utils.create_aec_decoder() 
          else:
             if not cfg.aec_train_fn is None:
                cfg.aec_train_fn.free(); cfg.aec_eval_fn.free(); cfg.aec_drv_fn.free();
             cfg.aec_train_fn,cfg.aec_eval_fn, cfg.aec_drv_fn = cpbn_utils.create_pbn_aec() 
             cfg.aec_decod_fn = cpbn_utils.create_aec_decoder() 
          self.aecb["fg"] = "green"
          print('Done creating graph')


    def dpbn_init(self): 
         self.update_cfg()
         scriptlog('DPBNINIT '+str(cfg.dpbn_ilyr))
         conv_utils.init_sgd( )
         if cfg.inshft[0]+cfg.inshft[1]>0:
             print('compiling pp_fn')
             cfg.pp_fn.free()
             cfg.pp_fn = cpbn_utils.create_pp_fn()
         cfg.ilayer=cfg.nlayer-1
         if not cfg.gpbn_train_fn is None:
            cfg.gpbn_train_fn.free(); cfg.gpbn_eval_fn.free(); cfg.gpbn_drv_fn.free();
         print('creating graphs for DPBN')
         cfg.gpbn_train_fn,cfg.gpbn_eval_fn,cfg.gpbn_drv_fn= cpbn_utils.create_fast_gpbn()
         self.gpbb["fg"] = "green"
         #self.fpbn_syn2_init() # also init fast_sp_fns
         cfg.ilayer=int(self.ilyr_txt.get())
         print('Done creating graph')

    def gmm_init(self): 
        self.update_cfg()
        run_fns.gmm('init')

    def gmm_train(self): 
        self.update_cfg()
        run_fns.gmm('train')

    def gmm_save(self): 
        self.update_cfg()
        run_fns.gmm('save')

    def gmm_load(self): 
        self.update_cfg()
        run_fns.gmm('load')

    def rbm_init(self): 
         conv_utils.init_sgd()
         if cfg.inshft[0]+cfg.inshft[1]>0:
             print('compiling pp_fn')
             cfg.pp_fn.free()
             cfg.pp_fn = cpbn_utils.create_pp_fn()
         for ilyr in range(cfg.nlayer):
           if not cfg.dbn_train_fn[ilyr] is None:
                cfg.dbn_train_fn[ilyr].free()
                cfg.dbn_train_fn[ilyr] = None
           if not cfg.dbn_eval_fn[ilyr] is None:
                cfg.dbn_eval_fn[ilyr].free()
                cfg.dbn_eval_fn[ilyr] = None
           if not cfg.cdbn_train_fn[ilyr] is None:
                cfg.cdbn_train_fn[ilyr].free()
                cfg.cdbn_train_fn[ilyr] = None
                cfg.cdbn_eval_fn[ilyr].free()
                cfg.cdbn_eval_fn[ilyr] = None
         if not cfg.fe_class_fn is None:
              cfg.fe_class_fn.free()
              cfg.fe_class_fn = None
         self.rbmb["fg"] = "red"

    def fpbn_syn2_init(self):
        self.update_cfg()
        if not cfg.fwd_fn is None:
             cfg.fwd_fn.free()
        print('Recompiling FWD')
        cfg.fwd_fn = cpbn_utils.create_fwd()
        for ilyr in range(cfg.nlayer):
          if not cfg.sp_fn[ilyr] is None:
             cfg.sp_fn[ilyr].free()
             cfg.sp_fn[ilyr] = None
        print('creating graphs for UMS synth')
        sp_fns= cpbn_utils.create_fast_sp_fns( )
        cfg.sp_fn[0:len(sp_fns)]=sp_fns
        self.E3s["fg"] = "green"
        print('Done creating graph')

    # [FG]
    def aa_init(self):
         self.update_cfg()
         if cfg.inshft[0]+cfg.inshft[1]>0:
             print('compiling pp_fn')
             cfg.pp_fn.free()
             cfg.pp_fn = cpbn_utils.create_pp_fn()
         print('creating graphs for AA')
         cfg.aa_fns = cpbn_utils.create_aa_fns()
         self.aa_btn_init["fg"] = "green"
 
         print('Done creating graph')

    def fe_init(self):
         self.update_cfg()
         if not cfg.fe_cls_fn is None:
              cfg.fe_cls_fn.free()
         cfg.fe_cls_fn = cpbn_utils.create_fwd_fe_classifier( )
         self.fe_btn_init["fg"] = "green"
         print('Done creating graph')

    def fe_run(self):
        self.update_cfg()
        run_fns.run_fe()

    def pbc_evl(self):
        self.update_cfg()
        run_fns.run_pbc('eval')

    def pbc_aa(self):
        self.update_cfg()
        run_fns.run_pbc('aa')

    def fd_create(self):
        self.update_cfg()
        ilayer=cfg.gmm_lyr
        dname=self.fdata_txt.get()
        print("**** Creating data set", dname, "from GMM layer ", ilayer)
        run_fns.create_feat_data_set(ilayer,dname)

    def fpbn_updn_init(self):
        self.update_cfg()
        if cfg.inshft[0]+cfg.inshft[1]>0:
             print('compiling pp_fn')
             cfg.pp_fn.free()
             cfg.pp_fn = cpbn_utils.create_pp_fn()
        conv_utils.init_sgd()
        print('Creating updn')
        cfg.updn_train_fn,cfg.updn_eval_fn = cpbn_utils.create_updn()
        self.E3u["fg"] = "green"
        print('Done creating graph')

    def lyr_init(self):
        self.update_cfg()
        run_fns.run_init()

    def fwd_init(self):
        self.update_cfg()
        print('creating graphs for FWD')
        cfg.fe_class_fn=None
        if not cfg.fwd_fn is None:
             cfg.fwd_fn.free() 
        cfg.fwd_fn = cpbn_utils.create_fwd( )
        self.fwdi["fg"] = "green"
        if len(cfg.lyrs)<cfg.nlayer or cfg.lyrs[cfg.nlayer-1] is None or not hasattr(cfg.lyrs[cfg.nlayer-1],'type'):
            print('Error: did you import a model?')
            return
        if cfg.lyrs[cfg.nlayer-1].type=='dbn':
           if not cfg.fe_class_fn is None:
              cfg.fe_class_fn.free()
           print('compiling fe_class function')
           cfg.fe_class_fn = cpbn_utils.create_fe_class(cfg.lyrs[cfg.nlayer-1])
        print('Done creating graphs')


    def fpbn_init(self):
        self.update_cfg()
        scriptlog('PBNINIT')
        conv_utils.init_sgd( )
        if cfg.inshft[0]+cfg.inshft[1]>0:
             print('compiling pp_fn')
             cfg.pp_fn.free()
             cfg.pp_fn = cpbn_utils.create_pp_fn()
        cfg.fpbn_class = cfg.train_class
        cfg.fpbn_pfx = cfg.prefix

        # ----  FREE existing graphs ----------
        if not cfg.fpbn_train_fn is None:
          cfg.fpbn_train_fn.free(); cfg.fpbn_eval_fn.free(); cfg.fpbn_drv_fn.free();
        if not cfg.fpbn_train_fn_short is None:
          cfg.fpbn_train_fn_short.free(); cfg.fpbn_eval_fn_short.free(); cfg.fpbn_drv_fn_short.free();

        print('creating graphs for PBN')
        cfg.fpbn_train_fn,cfg.fpbn_eval_fn,cfg.fpbn_drv_fn = cpbn_utils.create_fast_pbn_exact()

        self.E3c["fg"] = "green"
        print('Done creating graph')

    def fpbn_eval(self):

       # set mode
       self.update_cfg()
       
       # get test data sets as tuple
       idtr=str.split(self.idatat_txt.get(),",")

       # if prefix changed from last time, need to read in the model
       cfg.prefix = self.prefix_txt.get()
       if cfg.fpbn_pfx != cfg.prefix  :
           load_model()
 
       if cfg.dataset_type==2:
           # streaming
           run_fns.run_fpbn('eval')
           return
       for id in idtr: 
            cfg.test_class = id
            data_sets.load_data(id)
            conv_utils.init_streaming()
            run_fns.run_fpbn('eval')

    def dpbn_eval(self):
       # set mode 
       print('nl=',cfg.nlayer)
       self.update_cfg()

       idtr=str.split(self.idatat_txt.get(),",")

       if cfg.dataset_type==2:
           # streaming
           if idtr[0] != cfg.train_class:
               data_sets.load_data(idtr[0])
               self.loadmodel()
               run_fns.run_fast_gpbn('eval')
               data_sets.load_data(cfg.train_class)
               self.loadmodel()
           else:
               run_fns.run_fast_gpbn('eval')
           return

       # get test data sets as tuple
       for id in idtr: 
            cfg.test_class = id
            data_sets.load_data(id)
            run_fns.run_fast_gpbn('eval')

    def set_s2(self):
        self.update_cfg()
        ilyr = int(self.show_lyr_txt.get())
        s2 = float(self.s2_txt.get())
        if not hasattr(cfg.lyrs[ilyr],'s2'):
           print('layer ', ilyr, ' empty')
           return
        cfg.lyrs[ilyr].s2.set_value(s2)

    def scale_wts(self):
        self.update_cfg()
        ilyr = int(self.show_lyr_txt.get())
        fac = float(self.scale_fac_txt.get())
        run_fns.scale_wts(ilyr,fac)

    def aec_eval(self):

       # set mode
       self.update_cfg()
       # get test data sets as tuple
       idtr=str.split(self.idatat_txt.get(),",")

       for id in idtr: 
           cfg.test_class = id
           if cfg.test_class != cfg.train_class:
              if cfg.dataset_type==2:
                  print('Error, for streaming, you must load training set, and reload module')
                  return
              data_sets.load_data(id)
           run_fns.run_aec('eval')

    def aec_decode(self):
      if cfg.i_syn_rnd:
         run_fns.run_aec_decode()
         return
      self.update_cfg()
      fn = 'zin.mat'
      if not os.path.isfile(fn):
         print('File ' + fn  + ' not found')
         return
      matfile = scio.loadmat('zin.mat') 
      if not 'zin' in matfile :
         print('feature file zin needs to have variables \'zin\'')
         return
      cfg.zin = np.transpose(matfile['zin'])
      dim = cfg.lyrs[cfg.nlayer-1].odim
      if cfg.zin.shape[0] != cfg.batchsize or cfg.zin.shape[1] != dim:
         print('zin needs to be (batchsize X out_dimention)=(', cfg.batchsize, 'x', dim,'), bit is:', cfg.zin.shape)
         return
      run_fns.run_aec_decode()

    def pbn_decode(self):
      self.update_cfg()
      fn = 'zin.mat'
      if not os.path.isfile(fn):
         print('File ' + fn  + ' not found')
         return
      matfile = scio.loadmat('zin.mat') 
      if not 'zin' in matfile :
         print('feature file zin needs to have variables \'zin\'')
         return
      cfg.zin = np.transpose(matfile['zin'])
      dim = cfg.lyrs[cfg.nlayer-1].odim
      if cfg.zin.shape[0] != cfg.batchsize or cfg.zin.shape[1] != dim:
         print('zin needs to be (batchsize X out_dimention)=(', cfg.batchsize, 'x', dim,'), bit is:', cfg.zin.shape)
         return
      run_fns.run_pbn_decode()

    def aec_syn(self):
       self.update_cfg()
       run_fns.run_aec('recon')

    def fpbn_syn2(self):
       self.update_cfg()
       run_fns.run_ums2()


    def fpbn_drv(self):
       self.update_cfg()
       res=run_fns.run_fpbn_drv('pbn')

    def gpbn_drv(self):
       self.update_cfg()
       res=run_fns.run_fpbn_drv('dpbn')

    def aec_drv(self):
       self.update_cfg()
       res=run_fns.run_fpbn_drv('aec')

    def rundbn(self):
       self.update_cfg()
       # use isave=10 for RBM
       isv = cfg.isave
       cfg.isave = isv*10
       conv_utils.init_sgd( )   
       run_fns.run_dbn()
       cfg.isave = isv  # restore isave

    def synrbm(self):
       self.update_cfg()
       lyr_out,cst,xpm = cfg.cdbn_eval_fn[cfg.rbm_lyr](int(0), int(cfg.batchsize),0)
       print('xpm is shape ', xpm.shape)
       run_fns.displ_recon(cfg.batchsize, data.X_train[0:cfg.batchsize], xpm)

    def syndbn(self):
       self.update_cfg()
       xin,xpm=run_fns.dbn_syn()
       run_fns.displ_recon(cfg.batchsize, xin, xpm)
    
    def fpbn_rbm(self):
       self.update_cfg()
       # use isave=10 for RBM
       isv = cfg.isave
       cfg.isave = isv*10
       run_fns.run_pbn_rbm()
       cfg.isave = isv  # restore isave

    def fpbn_fwd(self):
       self.update_cfg()
       cfg.eval_data = self.eval_data.get()
       run_fns.run_fwd()

    def createWidgets(self):

 
        # GENERAL FRAME 
        frame0 = Frame(self, relief=RAISED, borderwidth=1)
        frame0.pack(fill=BOTH, expand=True)

        frame0b = Frame(frame0, relief=RAISED, borderwidth=1)
        self.QUIT=action_button(frame0b,"QUIT", self.quit, "red", side=None)
        self.E8=action_button(frame0b,"Refresh", self.reload_modules, side=None, wd=5)
        frame0b.pack(side=RIGHT)

        frame11g = Frame(frame0, relief=RAISED, borderwidth=1)
        self.savestate =checkbox(frame11g, "SAVE", self.chgsavstatus, side=None)
        self.plotstate =checkbox(frame11g, "PLT", self.chgpltstatus, side=None)
        frame11g.pack(side=RIGHT) 

        self.lr_txt,_=entry_field(frame0, "L.RATE", str(cfg.lr), 6,  side=RIGHT)
        self.l2r_txt,_=entry_field(frame0, "L2.REG", str(cfg.l2_reg), 7,  side=RIGHT)
        self.decay_txt,_=entry_field(frame0, "DECAY", str(cfg.decay), 6,  side=RIGHT)
        self.verb_txt,_=entry_field(frame0, "VERB", str(cfg.verbosity), 5,  side=RIGHT)
        self.amin_txt,_=entry_field(frame0, "AMIN", str(cfg.amin), 6,  side=RIGHT)
        frame0c = Frame(frame0, relief=RAISED, borderwidth=1)
        #self.egy =checkbox(frame0c, "egy", self.egy_chgstatus, side=None,bg='red')
        #self.egy.set(cfg.use_egy)
        frame0c.pack(side=RIGHT)
        frame0cc = Frame(frame0, relief=RAISED, borderwidth=1)
        self.rbstate =checkbox(frame0cc, "r.bias", self.reconbias_chgstatus, bg='red', side=None)
        self.rbstate.set(cfg.use_recon_bias)
        self.rwstate =checkbox(frame0cc, "r.wts", self.reconwts_chgstatus, bg='red', side=None)
        self.rwstate.set(cfg.use_recon_wts)
        frame0cc.pack(side=RIGHT)

        frame0ccm = Frame(frame0, relief=RAISED, borderwidth=1)
        self.invnl =checkbox(frame0ccm, "inv.nl", self.invnl_chgstatus,  bg='red', side=None)
        self.invnl.set(cfg.invert_NL)
        frame0ccm.pack(side=RIGHT)

        frame0ccc = Frame(frame0, relief=RAISED, borderwidth=1)
        self.fws2 =checkbox(frame0ccc, "fwd.s2", self.fws2_chgstatus,  bg='red', side=None)
        self.fws2.set(cfg.fwd_s2)
        self.fss2 =checkbox(frame0ccc, "fst.s2", self.fss2_chgstatus,  bg='red', side=None)
        self.fss2.set(cfg.fast_s2)
        frame0ccc.pack(side=RIGHT)

        self.mthd_txt,_=entry_field(frame0, "MTHD", str(cfg.method), 6,  side=RIGHT, bg='red')
        self.bs_txt,_=entry_field(frame0, "BS", str(cfg.batchsize), 4,  side=RIGHT, bg='red')
        self.lv_txt,_=entry_field(frame0, "LVAL", str(cfg.LABVAL), 5,  side=RIGHT, bg='red')

        # DATA SET / MODEL FRAME 
        frame1 = Frame(self, relief=RAISED, borderwidth=1)
        frame1.pack(fill=BOTH, expand=True)

        frame0a = Frame(frame1, relief=RAISED, borderwidth=1)
        frame0aa = Frame(frame0a, borderwidth=1)
        self.idata_txt,_=entry_field(frame0aa, "TRAIN DATA", cfg.train_class, 12,  side=LEFT)
        frame0aa.pack(side=None)
        self.idatat_txt,_=entry_field(frame0a, "EVAL DATA", cfg.test_class, 12,  side=LEFT)
        frame0a.pack(side=LEFT)

        frame00a = Frame(frame1, relief=RAISED, borderwidth=1)
        frd =  Frame(frame00a,  relief=RAISED, borderwidth=1)
        self.dataset_type=IntVar()
        Radiobutton(frd, text='Default', height=0,variable=self.dataset_type, value=0).pack()
        Radiobutton(frd, text='Big', height=0, variable=self.dataset_type, value=1).pack()
        Radiobutton(frd, text='Stream', height=0, variable=self.dataset_type, value=2).pack()
        self.dataset_type.set(cfg.dataset_type)
        frd.pack(side=None)
        self.E1b=action_button(frame00a,"LOAD", self.loaddata, side=None)
        frame00a.pack(side=LEFT)

        frame00a = Frame(frame1, relief=RAISED, borderwidth=1)
        fru =  Frame(frame00a,  relief=RAISED, borderwidth=1)
        fru.pack(side=None)
        self.minvar_txt,_=entry_field(frame00a, "VAR", str(cfg.minvar), 6,  eside=LEFT, side=None)
        self.ishft_txt,_=entry_field(frame00a, "SHFT", str(cfg.inshft[0])+','+str(cfg.inshft[1]), 5,  eside=LEFT, side=None, bg='red')
        self.cshft_txt,_=entry_field(frame00a, "CIRC", str(cfg.cshft[0])+','+str(cfg.cshft[1]), 5,  eside=LEFT, side=None, bg='red')
        self.irandcb =checkbox(frame00a, "Rand", self.rand_chgstatus, side=LEFT)
        frame00a.pack(side=LEFT)

        frd =  Frame(frame1,  relief=RAISED, borderwidth=1)
        self.aacb =checkbox(frd, "AA", self.aadata_chgstatus, side=None)
        self.iwt_txt,_=entry_field(frd, "cWt", str(cfg.iclass_wt), 2,   bg='red', eside=LEFT,side=None)
        self.wl_txt,_=entry_field(frd, "WL", str(cfg.windowlen), 4,   bg='red', eside=LEFT,side=None)
        frd.pack(side=LEFT)

        label(frame1, " ", side=LEFT) # spacer
        frt =  Frame(frame1,  relief=RAISED, borderwidth=1)
        self.eval_data=IntVar()
        Radiobutton(frt, text='train', height=0,variable=self.eval_data, value=0).pack()
        Radiobutton(frt, text='valid', height=0, variable=self.eval_data, value=1).pack()
        Radiobutton(frt, text='test', height=0, variable=self.eval_data, value=2).pack()
        Radiobutton(frt, text='AA', height=0, variable=self.eval_data, value=3).pack()
        self.eval_data.set(cfg.eval_data)
        frt.pack(side=LEFT)

        self.sigmoid_state=IntVar()
        frt =  Frame(frame1,  relief=RAISED, borderwidth=1)
        self.fwdi=action_button(frt,"FWD", self.fwd_init, 'red',  side=None)
        self.gmmsv =checkbox(frt, "Mem", self.gmmsv_chgstatus, side=None)
        self.E7=action_button(frt,"GO", self.fpbn_fwd,side=None)
        self.gmmsv.set(cfg.save_gmm)
        frt.pack(side=LEFT)
        frs =  Frame(frame1,  relief=RAISED, borderwidth=1)
        Radiobutton(frs, text='none', height=0,variable=self.sigmoid_state, value=0).pack()
        Radiobutton(frs, text='sigmoid', height=0, variable=self.sigmoid_state, value=1).pack()
        Radiobutton(frs, text='softmax', height=0, variable=self.sigmoid_state, value=2).pack()
        Radiobutton(frs, text='gmm', height=0, variable=self.sigmoid_state, value=3,side=None).pack()
        frs.pack(side=LEFT)
        self.sigmoid_state.set(0)

        label(frame1, " ", side=LEFT) # spacer

        frame10g = Frame(frame1, relief=RAISED, borderwidth=1)
        frame10gd = Frame(frame10g, relief=RAISED, borderwidth=1)
        action_button(frame10gd,"GMM", self.gmm_init, 'red', side=LEFT)
        self.gmod_txt,_=entry_field(frame10gd, "M", str(cfg.gmm_mod), 4,  side=LEFT)
        self.glyr_txt,_=entry_field(frame10gd, "LYR", str(cfg.gmm_lyr), 5,  side=LEFT)
        frame10gd.pack(side=None) 
        frame10ge = Frame(frame10g, relief=RAISED, borderwidth=1)
        action_button(frame10ge, "TRN", self.gmm_train, side=LEFT)
        self.gmm_std_txt,_=entry_field(frame10ge, "MIN-S", str(cfg.gmm_std), 5,  side=LEFT)
        action_button(frame10ge, "SAV", self.gmm_save, side=LEFT)
        #action_button(frame10ge, "LOAD", self.gmm_load, side=LEFT)
        frame10ge.pack(side=None) 
        frame10g.pack(side=LEFT) 


#        label(frame1, " ", side=LEFT) # spacer
#
#        self.partition_train=IntVar()
#        frame10h =  Frame(frame1,  relief=RAISED, borderwidth=1)
#        Radiobutton(frame10h, text='Part. off', height=0, variable=self.partition_train, value=1,bg='red').pack(side=None)
#        Radiobutton(frame10h, text=' normal ', height=0, variable=self.partition_train, value=0,bg='red').pack(side=None)
#        Radiobutton(frame10h, text=' invert  ', height=0, variable=self.partition_train, value=2,bg='red').pack(side=None)
#        frame10h.pack(side=LEFT)
#        self.partition_train.set(cfg.partition_train)


        # NETWORK  FRAME
        frame4 = Frame(self, relief=RAISED, borderwidth=1)
        frame4.pack(fill=BOTH, expand=True)

        frame1b = Frame(frame4, borderwidth=1)
        self.prefix_txt,_=entry_field(frame1b, "MODEL", cfg.prefix, 12,  side=None)
        frame1bb = Frame(frame1b, borderwidth=1)
        self.E2b=action_button(frame1bb,"LOAD", self.loadmodel,side=LEFT)
        action_button(frame1bb,"SAVE", self.savemodel,side=LEFT)
        frame1bb.pack(side=None)
        action_button(frame1b,"DELETE", self.delmodel,side=None, bg='lightpink') 
        frame1b.pack(side=LEFT)
        label(frame4, " ", side=LEFT) # spacer

        frame4a = Frame(frame4, borderwidth=1)
        fr4a1=Label(frame4a, text="Type:",height=1); fr4a1.pack()
        fr4a2=Label(frame4a, text="Activn:",height=1); fr4a2.pack()
        fr4a3=Label(frame4a, text="Dropout:",height=1); fr4a3.pack()
        fr4a4=Label(frame4a, text="Update:",height=1,bg="red"); fr4a4.pack()
        fr4a4=Label(frame4a, text="UMS:",height=1); fr4a4.pack()
        frame4a.pack(side=LEFT)

        self.lyrupd = [None]*MAXLYR
        self.lyrums = [None]*MAXLYR
        self.lyrdo = [None]*MAXLYR
        self.lyrnl = [None]*MAXLYR
        self.lyrtxt = [None]*MAXLYR
        for i in range(MAXLYR):
           if i < cfg.nlayer:
               nl=str(cfg.lyrs[i].nonlin[1])
               if cfg.lyrs[i].type=='nl':
                 nc=cfg.lyrs[i].nnl
               else:
                 nc=cfg.lyrs[i].nchan_out
               typ=str(i)+':'+cfg.lyrs[i].type[0:2]+str(nc)
               if hasattr(cfg.lyrs[i],'input_dropout_fac'):
                  dof=str(cfg.lyrs[i].input_dropout_fac.get_value().item())
               else:
                  dof = "0"
           else:
               nl = " "
               typ = "  "
               dof = "  "
           self.lyrnl[i],self.lyrtxt[i],self.lyrdo[i],self.lyrupd[i],self.lyrums[i]=double_entry_field(frame4, typ , nl, dof, 7,  side=LEFT)

        fs42 =  Frame(frame4,  relief=RAISED, borderwidth=1)
        self.LDM=action_button(fs42,"APPLY", self.updatemodel,side=None,wraplength=1)
        #self.border_state=IntVar()
        #Radiobutton(fs42, text='valid', height=0,variable=self.border_state, value=0).pack()
        #Radiobutton(fs42, text='half', height=0,variable=self.border_state, value=1).pack()
        #self.border_state.set(0)
        fs42.pack(side=LEFT)


        # PBN FRAME
        frame3 = Frame(self, relief=RAISED, borderwidth=1)
        frame3.pack(fill=BOTH, expand=True)
        frame3d = Frame(frame3, relief=RAISED, borderwidth=1)  
        self.E3c=action_button(frame3d,"PBN", self.fpbn_init, 'red',  side=None)
        self.runstate =checkbox(frame3d, "TRN", self.fpbn_chgstatus, side=None)
        self.E4d=action_button(frame3d,"EVAL", self.fpbn_eval,side=None)
        frame3d.pack(side=LEFT)

        frame3a = Frame(frame3, relief=RAISED, borderwidth=1)
        #self.pfl =checkbox(frame3a, "Profile", self.pfl_chgstatus, side=None,bg='red')
        #self.pfl.set(cfg.do_profile)
        #action_button(frame3a,"PCA INIT", self.lyr_init,side=None)
        #self.exd =checkbox(frame3a, "ext.drv", self.esd_chgstatus, side=None, bg='red')
        #self.exd.set(cfg.exact_drv)
        self.us2_in =checkbox(frame3a, "upd.s2in", self.us2i_chgstatus, side=None)
        self.us2_in.set(cfg.update_s2_in)
        self.us2 =checkbox(frame3a, "upd.s2/v", self.us2_chgstatus, side=None)
        self.us2.set(cfg.update_s2)
        #self.usd =checkbox(frame3a, "dropout", self.usd_chgstatus, side=None)
        #self.usd.set(cfg.fpbn_use_dropout)
        self.swt =checkbox(frame3a, "save", self.swt_chgstatus, side=None)
        self.swt.set(cfg.save_while_train)
        self.lpo_txt,_=entry_field(frame3a, "beta", str(cfg.lpo_scale), 3,   bg='red', eside=LEFT,side=None)
        frame3a.pack(side=LEFT)

        frame3c = Frame(frame3, relief=RAISED, borderwidth=1)
        self.pp2 =checkbox(frame3c, "PLT", self.pltp_chgstatus, side=None)
        self.pp2.set(cfg.iplot_pbn)
        self.crse_txt,_=entry_field(frame3c, "XE", str(cfg.fpbn_crossent), 4,  eside=LEFT, side=None)
        self.clv_txt,_=entry_field(frame3c, "C", str(cfg.C), 4,  eside=LEFT, side=None)
        self.dcl =checkbox(frame3c, "class", self.dcl_chgstatus, side=None)
        self.dcl.set(cfg.do_class)
        frame3c.pack(side=LEFT)

        label(frame3, " ", side=LEFT) # spacer
        frame3e = Frame(frame3, relief=RAISED, borderwidth=1)
        self.spint=action_button(frame3e,"SP", self.sp_init, 'red', side=None) 
        self.spe_runstate =checkbox(frame3e, "TRN", self.spe_chgstatus, side=None)
        self.nit_sp_txt,_=entry_field(frame3e, "NIT", str(cfg.nit_sp_ng), 4,  side=None, eside=LEFT, bg='red')
        #self.his_sp_txt,_=entry_field(frame3e, "HIST", str(cfg.sp_hist), 4,  side=None, eside=LEFT, bg='red')
        frame3e.pack(side=LEFT)

        # DET-PBN sub FRAME
        label(frame3, " ", side=LEFT) # spacer
        frame7b = Frame(frame3, relief=RAISED, borderwidth=1)
        self.gpbb=action_button(frame7b,"DPBN", self.dpbn_init, 'red', side=None)  
        frame7ef = Frame(frame7b, relief=RAISED, borderwidth=1)
        self.gpbnrunstate =checkbox(frame7ef, "TRN", self.gpbn_chgstatus, side=LEFT)
        self.dpbn_ilyr_txt,_=entry_field(frame7ef, "LYR", str(cfg.dpbn_ilyr), 3,  side=LEFT, eside=LEFT)
        frame7ef.pack(side=None)
        frame7ee = Frame(frame7b, relief=RAISED, borderwidth=1)
        self.E4d2=action_button(frame7ee,"EVAL", self.dpbn_eval,side=LEFT)
        self.pdec=action_button(frame7ee,"DEC", self.pbn_decode,  side=LEFT)
        frame7ee.pack(side=None)

        frame7b.pack(side=LEFT) 

        label(frame3, " ", side=LEFT) # spacer
        fs03 =  Frame(frame3,  relief=RAISED, borderwidth=1)

        fs0x =  Frame(fs03,  relief=RAISED, borderwidth=1)
        self.ilyr_txt,_=entry_field(fs0x, "LYR", str(cfg.ilayer), 3,  side=None, eside=LEFT)
        self.rndcb =checkbox(fs0x, "rnd", self.rnd_chgstatus, side=None)
        self.rndcb.set(cfg.i_syn_rnd)
        self.gmmcb =checkbox(fs0x, "gmm", self.gmm_chgstatus, side=None)
        self.gmmcb.set(cfg.syn_use_gmm)
        self.synsrt =checkbox(fs0x, "sort", self.synsrt_chgstatus, side=None)
        self.synsrt.set(cfg.syn_sort_lik)
        fs0x.pack(side=None)

        fs0 =  Frame(frame3,  relief=RAISED, borderwidth=1)
        self.E3s=action_button(fs0,"SYN", self.fpbn_syn2_init, 'red',  side=None)
        self.nsyn_txt,_=entry_field(fs0, "n", str(cfg.n_syn), 3,  side=None, eside=LEFT)
        self.E6=action_button(fs0,"GO", self.fpbn_syn2,  side=None)
        fs0.pack(side=LEFT)

        fs03.pack(side=LEFT)

        label(frame3, " ", side=LEFT) # spacer
        fs0xx =  Frame(frame3,  relief=RAISED, borderwidth=1)
        self.drv_state=IntVar()
        self.drv_state.set(1)
        Radiobutton(fs0xx, text='W', height=0,variable=self.drv_state, value=1).pack()
        Radiobutton(fs0xx, text='b', height=0, variable=self.drv_state, value=2).pack()
        Radiobutton(fs0xx, text='s2', height=0, variable=self.drv_state, value=3).pack()
        Radiobutton(fs0xx, text='a', height=0, variable=self.drv_state, value=4).pack()
        fs0xx.pack(side=LEFT)
        fs02 =  Frame(frame3,  relief=RAISED, borderwidth=1)
        action_button(fs02,"PBN-Drv", self.fpbn_drv,  side=None)
        action_button(fs02,"DPBN-Drv", self.gpbn_drv,  side=None)
        action_button(fs02,"AEC-Drv", self.aec_drv,  side=None)
        #self.drvtrnstate =checkbox(fs02, "TRN", self.drvtrn_chgstatus, side=None)
        fs02.pack(side=LEFT)



       # # VIEW FRAME
       # frame6 = Frame(self, relief=RAISED, borderwidth=1)
       # frame6.pack(fill=BOTH, expand=True)   

 
        # MISC FRAME
        frame7 = Frame(self, relief=RAISED, borderwidth=1)
        frame7.pack(fill=BOTH, expand=True) 

        # AEC subframe 
        frame7a = Frame(frame7, relief=RAISED, borderwidth=1)

        frame7aa = Frame(frame7a, relief=RAISED, borderwidth=1)
        self.aecb=action_button(frame7aa,"AEC", self.aec_init, 'red', side=None)
        self.vae_beta_txt,_=entry_field(frame7aa, "VAE", str(cfg.vae_beta), 4,  bg='red', side=None, eside=LEFT)
        self.aecrunstate =checkbox(frame7aa, "TRN", self.aec_chgstatus, side=None)
        frame7aa.pack(side=LEFT) 

        frame7ab = Frame(frame7a, relief=RAISED, borderwidth=1)
        action_button(frame7ab,"SYN", self.aec_syn,side=None)
        action_button(frame7ab,"EVAL", self.aec_eval,side=None)
        self.aec_std_txt,_=entry_field(frame0, "STDV", str(cfg.aec_std), 4,  side=RIGHT)
        frame7ab.pack(side=LEFT) 

        frame7ac = Frame(frame7a, relief=RAISED, borderwidth=1)
        action_button(frame7ac,"DEC", self.aec_decode,side=None)
        self.aec_std_txt,_=entry_field(frame7ac, "STDV", str(cfg.aec_std), 4,  side=None)
        frame7ac.pack(side=LEFT) 

        frame7a.pack(side=LEFT) 

        label(frame7, " ", side=LEFT) # spacer

        frame7b = Frame(frame7, relief=RAISED, borderwidth=1)
        self.dnnb=action_button(frame7b,"DNN", self.dnn_init, 'red', side=None)
        self.mxpcb =checkbox(frame7b, "maxp", self.mxp_chgstatus, bg='red', side=None)
        self.xentcb =checkbox(frame7b, "x.ent", self.xent_chgstatus, bg='red', side=None)
        self.xentcb.set(cfg.UseCrossEntropy)
        self.dnnrunstate =checkbox(frame7b, "TRN", self.dnn_chgstatus, side=None)
        frame7b.pack(side=LEFT) 


#        # PI subframe
#        label(frame7, " ", side=LEFT) # spacer
#        frame10a = Frame(frame7, relief=RAISED, borderwidth=1)
#        self.pib=action_button(frame10a,"PI", self.pi_init, 'red', side=None)
#        self.pirunstate =checkbox(frame10a, "TRN", self.pi_chgstatus, side=None)
#        frame10a.pack(side=LEFT) 

        label(frame7, " ", side=LEFT) # spacer
        frame10d = Frame(frame7, relief=RAISED, borderwidth=1)
        frame10dd = Frame(frame10d, relief=RAISED, borderwidth=1)
        self.rbmb=action_button(frame10dd,"RBM", self.rbm_init, 'red', side=LEFT)
        self.rlyr_txt,_=entry_field(frame10dd, "LYR", str(cfg.rbm_lyr), 4,  side=LEFT, eside=LEFT)
        frame10dd.pack(side=None) 
        frame10de = Frame(frame10d, relief=RAISED, borderwidth=1)
        action_button(frame10de, "TRN", self.fpbn_rbm, side=LEFT)
        self.epoch_txt,_=entry_field(frame10de, "EP", str(cfg.epochs), 4,  side=LEFT, eside=LEFT)
        frame10de.pack(side=None) 
        frame10df = Frame(frame10d, relief=RAISED, borderwidth=1)
        self.rbmrnd =checkbox(frame10df, "rnd", self.rbmrnd_chgstatus, side=LEFT,bg='red')
        self.rbmrnd.set(cfg.rbm_rnd)
        self.rbmW =checkbox(frame10df, "Wts", self.rbmW_chgstatus, side=LEFT,bg='red')
        self.rbmW.set(cfg.rbm_trainwts)
        frame10df.pack(side=None) 
        frame10d.pack(side=LEFT) 


        frame10j = Frame(frame7, relief=RAISED, borderwidth=1)
        action_button(frame10j,"DBN-SYN", self.syndbn, side=None)
        self.dbncl =checkbox(frame10j, "dpbn", self.dbnpbnsyn_chgstatus, side=None)
        self.dbncl.set(cfg.dbnpbnsyn)
        self.dbn_nk_txt,_=entry_field(frame10j, "NK", str(cfg.dbn_nk), 3,  bg='red', side=None, eside=LEFT)
        frame10j.pack(side=LEFT) 

        frame10f = Frame(frame7, relief=RAISED, borderwidth=1)
        label(frame10f, " MXP ", side=None) # spacer
        action_button(frame10f,"TRN", self.rundbn, side=None)
        action_button(frame10f,"SYN", self.synrbm, side=None)
        frame10f.pack(side=LEFT) 

        label(frame7, " ", side=LEFT) # spacer
        wtsframe2 =  Frame(frame7,  relief=RAISED, borderwidth=1)
        self.f6aa=action_button(wtsframe2,"Nrm", self.pca_nrm,side=None)
        self.f6aa=action_button(wtsframe2,"Zro", self.pca_zro,side=None)
        self.f6a=action_button(wtsframe2,"PCA", self.pca_wts,side=None)
        wtsframe2.pack(side=LEFT)
        wtsframe =  Frame(frame7,  relief=RAISED, borderwidth=1)
        frame12i =  Frame(wtsframe,  relief=RAISED, borderwidth=1)
        frame12h =  Frame(wtsframe,  relief=RAISED, borderwidth=1)
        self.show_lyr_txt,_=entry_field(frame12h, "LYR", str(cfg.show_lyr), 4,  side=LEFT, eside=LEFT)
        self.f6a=action_button(frame12h,"Show", self.show_wts,side=LEFT)
        frame12h.pack(side=None)
        frame11h =  Frame(wtsframe,  relief=RAISED, borderwidth=1)
        self.scale_fac_txt,_=entry_field(frame11h, "Fac", str(1.0), 4,  side=LEFT, eside=LEFT)
        action_button(frame11h,"Scale", self.scale_wts,side=LEFT, wd=4)
        frame11h.pack(side=None)
        frame11i =  Frame(wtsframe,  relief=RAISED, borderwidth=1)
        self.s2_txt,_=entry_field(frame11i, "s2", str(1.0), 4,  side=LEFT, eside=LEFT)
        action_button(frame11i,"set", self.set_s2,side=None)
        frame11i.pack(side=None)
        wtsframe.pack(side=LEFT)


        frame8 = Frame(self, relief=RAISED, borderwidth=1)
        frame8.pack(fill=BOTH, expand=True) 

        # [FG]
        # Adversarial frame
        frame_ad = Frame(frame8, relief=RAISED, borderwidth=1)
        self.aa_btn_init = action_button(frame_ad, "AA", self.aa_init, 'red', side=None)
        self.aa_n_txt, _ = entry_field(frame_ad, "n", str(cfg.aa_n), 3, side=None, eside=LEFT)
        frame_ad.pack(side=LEFT)
        frame_ad2 = Frame(frame8, relief=RAISED, borderwidth=1)
        self.aa_eps_txt, _ = entry_field(frame_ad2, "EPS", str(cfg.aa_eps), 3, side=None, eside=LEFT)
        self.aa_target_txt, _ = entry_field(frame_ad2, "TRG", ' ', 3, side=None, eside=LEFT)
        self.aa_btn_go = action_button(frame_ad2, "GO", run_fns.run_aa_attack, side=None)
        frame_ad2.pack(side=LEFT)
        frame_ad3 = Frame(frame8, relief=RAISED, borderwidth=1)
        self.aa_btn_data = action_button(frame_ad3, "Data", run_fns.run_aa_data, side=None)
        frame_ad3.pack(side=LEFT)

        label(frame8, " ", side=LEFT) # spacer
        frame10c = Frame(frame8, relief=RAISED, borderwidth=1)
        self.E3u=action_button(frame10c,"UPDN", self.fpbn_updn_init, 'red',  side=None)
        self.dbnrnd =checkbox(frame10c, "rnd", self.dbnrnd_chgstatus, side=None,bg='red')
        self.dbnrnd.set(cfg.dbn_rnd)
        self.updn_runstate =checkbox(frame10c, "TRN", self.updn_chgstatus, side=None)
        frame10c.pack(side=LEFT) 

        label(frame8, " ", side=LEFT)  # spacer

        # FE class frame
        frame_fe = Frame(frame8, relief=RAISED, borderwidth=1)
        self.fe_btn_init = action_button(frame_fe, "FE", self.fe_init, 'red', side=None)
        self.fe_btn_go = action_button(frame_fe, "GO", self.fe_run, side=None)
        frame_fe.pack(side=LEFT)

        label(frame8, " ", side=LEFT)  # spacer

        # PBN-C frame
        frame_pbc = Frame(frame8, relief=RAISED, borderwidth=1)
        label(frame_pbc, "PBN-C", side=None)  # spacer
        self.pbnc_evl = action_button(frame_pbc, "EVAL", self.pbc_evl, side=None)
        self.pbnc_AA = action_button(frame_pbc, "AA", self.pbc_aa, side=None)
        frame_pbc.pack(side=LEFT)

        label(frame8, " ", side=LEFT)  # spacer

        # Feature Data Layer
        frame_fd = Frame(frame8, relief=RAISED, borderwidth=1)
        self.fdata_txt,_=entry_field(frame_fd, "DATA SET", "", 12,  side=None)
        action_button(frame_fd, "Create", self.fd_create, side=None)
        frame_fd.pack(side=LEFT)

        label(frame8, " ", side=LEFT)  # spacer

        #frcs =  Frame(frame8,  relief=RAISED, borderwidth=1)
        #action_button(frcs,"CSPEC", self.cspec_init, 'red',  side=None)
        #self.csp_runstate =checkbox(frcs, "TRN", self.csp_chgstatus, side=None)
        #frcs.pack(side=LEFT)
        #
        #label(frame8, " ", side=LEFT)  # spacer

        frkn =  Frame(frame8,  relief=RAISED, borderwidth=1)
        self.knn_runstate =checkbox(frkn, "KNN", self.knn_chgstatus, side=None)
        action_button(frkn,"GO", self.run_knn,  side=None)
        self.knn_k_txt, _ = entry_field(frkn, "K", str(cfg.knn_k), 3, side=None, eside=LEFT)
        frkn.pack(side=LEFT)

        label(frame8, " ", side=LEFT)  # spacer

        fs0zz =  Frame(frame8,  relief=RAISED, borderwidth=1)
        label(fs0zz, "Labels", side=None) 
        self.labt_state=IntVar()
        frs =  Frame(fs0zz,  relief=RAISED, borderwidth=1)
        Radiobutton(frs, text='one-hot', height=0,variable=self.labt_state, value=0).pack()
        Radiobutton(frs, text='prob', height=0, variable=self.labt_state, value=1).pack()
        Radiobutton(frs, text='o.h.+rgb', height=0, variable=self.labt_state, value=2).pack()
        frs.pack(side=None)
        fs0zz.pack(side=LEFT)
        self.labt_state.set(0)

        #fs0zy =  Frame(frame8,  relief=RAISED, borderwidth=1)
        #label(fs0zy, "Mod", side=None) 
        #self.modt_state=IntVar()
        #frs2 =  Frame(fs0zy,  relief=RAISED, borderwidth=1)
        #Radiobutton(frs2, text='mod', height=0,variable=self.modt_state, value=0).pack()
        #Radiobutton(frs2, text='py', height=0, variable=self.modt_state, value=1).pack()
        #frs2.pack(side=None)
        #fs0zy.pack(side=LEFT)
        #self.modt_state.set(0)

    def __init__(self, master=None):
        Frame.__init__(self, master)
        self.pack()
        self.createWidgets()
        self.is_playing = False


def scanplots():
    # allocate time to process plots in background
    root.after(1000, scanplots) # every half second
    run_fns.refresh_plots()


# executa a 1-line operation
def op_line(sl,lp):
     if sl[0]=='SCRIPT':
         if lp.nloop>0:
             if sl[1]=='ENDLOOP':
                 lp.loopsize=lp.iloop
                 nlp= lp.nloop
                 lp.nloop=0
                 for i in range(nlp):
                    for j in range(lp.loopsize):
                        slt= lp.sl_loop[j].copy()
                        for l in range(len(slt)):
                            loc=slt[l].find('II+1')
                            if loc>-1:
                              slt[l]=slt[l][0:loc]+str(i+1)+slt[l][loc+4:]
                            else:
                              loc=slt[l].find('II')
                              if loc>-1:
                                 slt[l]=slt[l][0:loc]+str(i)+slt[l][loc+2:]
                        op_line(slt,lp)
             else:
                lp.sl_loop[lp.iloop]=sl
                lp.iloop+=1
         elif sl[1]=='STARTLOOP':
             lp.nloop=int(sl[2])
             lp.iloop = 0
         elif sl[1]=='QUIT':
            quit()
         elif sl[1]=='LOADDATA':
            cfg.train_class=sl[2]
            Application(master=None).loaddata()
         elif sl[1]=='LOADMODEL':
            cfg.prefix=sl[2]
            Application(master=None).loadmodel()
         elif sl[1]=='PBNINIT':
            Application(master=None).fpbn_init()
         elif sl[1]=='DNNINIT':
            Application(master=None).dnn_init()
         elif sl[1]=='DPBNINIT':
            cfg.dpbn_ilyr=int(sl[2])
            Application(master=None).dpbn_init()
         elif sl[1]=='DPBNTRAIN':
            cfg.epochs=int(sl[2])
            run_fns.run_fast_gpbn('train')
         elif sl[1]=='PBNTRAIN':
            cfg.epochs=int(sl[2])
            run_fns.run_fpbn('train')
         elif sl[1]=='PBNEVAL':
            Application(master=None).idatat_txt.delete(0, END)
            Application(master=None).idatat_txt.insert(0, sl[2])
            cfg.test_class = sl[2]
            Application(master=None).fpbn_eval()
         elif sl[1]=='DNNTRAIN':
            cfg.epochs=int(sl[2])
            run_fns.run_dnn()
         elif sl[1]=='FWD':
            cfg.iplot=0
            run_fns.run_fwd()
         elif sl[1]=='FWDINIT':
            Application(master=None).fwd_init()
         elif sl[1]=='SAVEMODEL':
            cfg.prefix=sl[2]
            Application(master=None).savemodel()
         elif sl[1]=='DELETE':
            cfg.prefix=sl[2]
            Application(master=None).delmodel()
         elif sl[1]=='RBMINIT':
            Application(master=None).rbm_init()
         elif sl[1]=='UPDNINIT':
            Application(master=None).fpbn_updn_init()
         elif sl[1]=='UPDNTRAIN':
            cfg.epochs=int(sl[2])
            run_fns.run_updn()
         elif sl[1]=='RBMTRAIN':
            cfg.epochs=int(sl[2])
            Application(master=None).fpbn_rbm()
         elif sl[1]=='PARAM':
            if sl[2]=='Dropout':
               print('SETTING dropout for layer',sl[3], 'to', sl[4])
               ilyr=int(sl[3])
               cfg.lyrs[ilyr].input_dropout_fac.set_value(float(sl[4]))
            elif sl[2]=='maxp':
               print('SETTING maxp to ',sl[3])
               cfg.use_maxpool = int(sl[3])
            elif sl[2]=='nlayer':
               print('SETTING nlayer to ',sl[3])
               cfg.nlayer = int(sl[3])
            elif sl[2]=='upd.s2':
               print('SETTING upd.s2 to ',sl[3])
               cfg.update_s2 = int(sl[3])
            elif sl[2]=='upd.s2in':
               print('SETTING upd.s2in to ',sl[3])
               cfg.update_s2_in = int(sl[3])
            elif sl[2]=='EPOCHS':
               print('SETTING EPOCHS to ',sl[3])
               cfg.epochs = int(sl[3])
            elif sl[2]=='cWt':
               print('SETTING iclass_wt to ',sl[3])
               cfg.iclass_wt = int(sl[3])
            elif sl[2]=='dataset_type':
               if sl[3]=='Default':
                  print('SETTING dataset_type to Default')
                  cfg.dataset_type=0
               elif sl[3]=='Big':
                  print('SETTING partition to Big')
                  cfg.dataset_type=1
               elif sl[3]=='Stream':
                  print('SETTING partition to Stream')
                  cfg.dataset_type=2
            elif sl[2]=='partition':
               if sl[3]=='train':
                  print('SETTING partition to train')
                  cfg.eval_data=0
               elif sl[3]=='valid':
                  print('SETTING partition to valid')
                  cfg.eval_data=1
               elif sl[3]=='test':
                  print('SETTING partition to test')
                  cfg.eval_data=2
            elif sl[2]=='L.RATE':
               print('SETTING L.RATE to ',sl[3])
               cfg.lr = float(sl[3])
            elif sl[2]=='L2.REG':
               print('SETTING L2.REG to ',sl[3])
               cfg.l2_reg = float(sl[3])
            elif sl[2]=='BS':
               print('SETTING BS to ',sl[3])
               cfg.batchsize = int(sl[3])
            elif sl[2]=='RBMLYR':
               print('SETTING RBMLYR to ',sl[3])
               cfg.rbm_lyr = int(sl[3])
            elif sl[2]=='XE':
               print('SETTING XE to ',sl[3])
               cfg.fpbn_crossent = float(sl[3])
            elif sl[2]=='C':
               print('SETTING C to ',sl[3])
               cfg.C = float(sl[3])
            elif sl[2]=='DECAY':
               print('SETTING DECAY to ',sl[3])
               cfg.decay = float(sl[3])
            elif sl[2]=='SAVE':
               print('SETTING SAVE to ',sl[3])
               cfg.isave = int(sl[3])
            elif sl[2]=='save':
               print('SETTING save_while_train to ',sl[3])
               cfg.save_while_train = int(sl[3])
            elif sl[2]=='fst.s2':
               print('SETTING fst.s2 to ',sl[3])
               cfg.fast_s2 = int(sl[3])
            elif sl[2]=='upd.s2in':
               print('SETTING upd.s2in to ',sl[3])
               cfg.update_s2_in = int(sl[3])
            elif sl[2]=='Update':
               ilyr = int(sl[3])
               print('SETTING layer',ilyr,'Update to ',sl[4])
               cfg.lyrs[ilyr].update= (int(sl[4])==1)
            else:
               print('UNKNOWN PARAMETER:', sl[2])
         else:
            print('UNKNOWN COMMAND:', sl[1])
     else:
        # inactive command or comment
        pass

set_defaults()
inits() 
conv_utils.init_sgd( )
loop_parms=Object()

loop_parms.nloop=0        # number of times to loop
loop_parms.loopsize=0     # number of commands in the loop
loop_parms.iloop=0        # current command in the loop
loop_parms.sl_loop=[None]*1000

if len(sys.argv) >1:
    filename = fn=sys.argv[1]
    print('loading ', filename)
    with open(filename,"r") as fp:
         line = fp.readline()
         lyrcnt = 0
         while line:
             sl=line.split()
             op_line(sl,loop_parms)
             line = fp.readline()
         quit()
    print('could not open ', filename)
    quit()

cfg.scan_ctr = 0
if AESARA:
  root.title("PBN Toolkit - AESARA (" + theano.config.device + '-' + theano.config.floatX + ')')
else:
  root.title("PBN Toolkit - THEANO (" + theano.config.device + '-' + theano.config.floatX + ')')
root.geometry(geom)
app = Application(master=root)
root.after(1000, scanning)  # After 1 second, start scanning for epoch processing
#root.after(2000, scanplots)  # After 2 sec, start scanning plots
app.mainloop()
root.destroy()
sys.exit()



