# decompyle3 version 3.9.0
# Python bytecode version base 3.7.0 (3394)
# Decompiled from: Python 3.7.11 (default, Jul 27 2021, 14:32:16) 
# [GCC 7.5.0]
# Embedded file name: TED.py
# Compiled at: 2022-04-08 08:11:20
# Size of source mod 2**32: 16773 bytes
from __future__ import print_function
import warnings, numpy, theano
from theano import config, printing, scalar
from theano.printing import pprint
from theano.tensor import basic as tensor
from theano.tensor import elemwise
from theano.tensor.type import values_eq_approx_remove_inf

def np_ted(x):
    if x < -30.0:
        return -1 / x
    if x > 30.0:
        return (x - 1) / x
    if abs(x) < 0.05:
        return 0.5 + x * (0.08333333333333333 - x * x / 720)
    bet = numpy.exp(x)
    out = bet / (bet - 1) - 1 / x
    return out


class ScalarTed(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        if x < -30.0:
            return -1 / x
        if x > 30.0:
            return (x - 1) / x
        if abs(x) < 0.05:
            return 0.5 + x * (0.08333333333333333 - x * x / 720)
        bet = numpy.exp(x)
        out = bet / (bet - 1) - 1 / x
        return out

    def impl(self, x):
        return ScalarTed.st_impl(x)

    def grad(self, inp, grads):
        x, = inp
        gz, = grads
        y = scalar_tedgrad(x)
        return [
         y * gz]

    def c_code(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32:
            return '{\n          float x2,  bet;\n          x2=%(x)s*%(x)s; bet=exp(%(x)s);\n          %(z)s = %(x)s < -30.0f ? -1.0f/%(x)s :                   %(x)s > 30.0f ? (%(x)s - 1.0f)/%(x)s :                    fabs(%(x)s) < 0.05f ? 0.5f + %(x)s*(1.0f/12.0f-x2/720.0f) :                   bet/(bet-1.0f)-1.0f/%(x)s;}' % locals()
        if node.inputs[0].type == scalar.float64:
            return '{\n          double x2,  bet;\n          x2=%(x)s*%(x)s; bet=exp(%(x)s);\n          %(z)s = %(x)s < -30.0 ? -1.0/%(x)s :                   %(x)s > 30.0 ? (%(x)s - 1.0)/%(x)s :                    fabs(%(x)s) < 0.05 ? 0.5 + %(x)s*(1.0/12.0-x2/720.0) :                   bet/(bet-1.0)-1.0/%(x)s;}' % locals()
        raise NotImplementedError('only floatingpoint is implemented')


scalar_ted = ScalarTed((scalar.upgrade_to_float), name='scalar_ted')
ted = elemwise.Elemwise(scalar_ted, name='ted')
ted_inplace = elemwise.Elemwise((ScalarTed(scalar.transfer_type(0))),
  inplace_pattern={0: 0},
  name='ted_inplace')

class ScalarTedGrad(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        bet = numpy.exp(x)
        x2 = x * x
        if abs(x) > 10.0:
            rval = 1.0 / x2
        else:
            if abs(x) < 0.1:
                rval = 0.08333333333333333 - x2 * (0.004166666666666667 - x2 * (0.00016534391534391533 - x2 * (5.787037037037037e-06 - x2 / 5322240)))
            else:
                rval = 1 / x2 - bet / (bet - 1.0) / (bet - 1.0)
        return rval

    def grad(self, inp, grads):
        x, = inp
        gz, = grads
        y = scalar_tedgrad2(x)
        return [
         y * gz]

    def impl(self, x):
        return ScalarTedGrad.st_impl(x)

    def c_code(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32 or node.inputs[0].type == scalar.float16:
            return '{\n               float x2, bet, xa;\n               bet=exp(%(x)s);\n               xa=fabs(%(x)s);\n               x2=%(x)s * %(x)s;\n               %(z)s = xa > 10.0f ? 1.0f/x2 : xa<0.1f ? (1.0f/12.0f-x2*(1.0f/240.0f                       -x2*(1.0f/6048.0f-x2*(1.0f/172800.0f-x2/5322240.0f)))) :                        1.0f/x2-bet/(bet-1.0f)/(bet-1.0f);\n            }' % locals()
        if node.inputs[0].type == scalar.float64:
            return '{\n               double x2, bet, xa;\n               bet=exp(%(x)s);\n               xa=fabs(%(x)s);\n               x2=%(x)s * %(x)s;\n               %(z)s = xa > 10.0 ? 1.0/x2 : xa<0.1 ? (1.0/12.0-x2*(1.0/240.0                       -x2*(1.0/6048.0-x2*(1.0/172800.0-x2/5322240.0)))) :                        1.0/x2-bet/(bet-1.0)/(bet-1.0);\n            }' % locals()
        raise NotImplementedError('only floatingpoint is implemented')


scalar_tedgrad = ScalarTedGrad((scalar.upgrade_to_float), name='scalar_tedgrad')
tedgrad = elemwise.Elemwise(scalar_tedgrad, name='tedgrad')

class ScalarTedGrad2(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        bet = numpy.exp(x)
        bet1 = bet - 1.0
        x2 = x * x
        if abs(x) > 25.0:
            rval = -2.0 / x2 / x
        else:
            if abs(x) < 0.1:
                rval = -x / 120.0 + x2 * x / 1512.0
            else:
                rval = -2.0 / x2 / x + (bet * bet + bet) / bet1 / bet1 / bet1
        return rval

    def impl(self, x):
        return ScalarTedGrad2.st_impl(x)

    def c_code(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32 or node.inputs[0].type == scalar.float16:
            return '{\n            float x2, bet, bet1, xa;\n               bet=exp(%(x)s);\n               bet1=bet-1.0f;\n               xa=fabs(%(x)s);\n               x2=%(x)s * %(x)s;\n               %(z)s = xa > 25.0f ? -2.0f/x2/%(x)s : xa<0.1f ? (-%(x)s/120.0f                       +x2*%(x)s/1512.0f) :                        -2.0f/x2/%(x)s+(bet*bet+bet)/bet1/bet1/bet1;\n            }' % locals()
        if node.inputs[0].type == scalar.float64:
            return ' {\n            double x2, bet, bet1, xa;\n               bet=exp(%(x)s);\n               bet1=bet-1.0;\n               xa=fabs(%(x)s);\n               x2=%(x)s * %(x)s; \n               %(z)s = xa > 25.0 ? -2.0/x2/%(x)s : xa<0.1 ? (-%(x)s/120.0                       +x2*%(x)s/1512.0) :                        -2.0/x2/%(x)s+(bet*bet+bet)/bet1/bet1/bet1;\n            }' % locals()
        raise NotImplementedError('only floatingpoint is implemented')


scalar_tedgrad2 = ScalarTedGrad2((scalar.upgrade_to_float), name='scalar_tedgrad2')
tedgrad2 = elemwise.Elemwise(scalar_tedgrad2, name='tedgrad2')

class ScalarTedCGF(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        bet = numpy.exp(x)
        bet1 = bet - 1.0
        e1w = bet1 / x
        x2 = x * x
        if x > 25.0:
            rval = x - numpy.log(x)
        else:
            if abs(x) < 0.1:
                rval = x / 2 + x2 / 24 - x2 * x2 / 2880
            else:
                rval = numpy.log(e1w)
        return rval

    def impl(self, x):
        return ScalarTedCGF.st_impl(x)

    def grad(self, inp, grads):
        x, = inp
        gz, = grads
        y = scalar_ted(x)
        return [
         y * gz]

    def c_code(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32 or node.inputs[0].type == scalar.float16:
            return '{\n               float x2,  xa;\n               xa=fabs(%(x)s);\n               x2=%(x)s * %(x)s;\n               %(z)s = %(x)s > 25.0f ? %(x)s -log(%(x)s) : xa<0.1f ? %(x)s/2.0f                       +x2/24.0f-x2*x2/2880.0f :                        log((exp(%(x)s)-1.0f)/%(x)s );\n            }' % locals()
        if node.inputs[0].type == scalar.float64:
            return '{\n               double x2,  xa;\n               xa=fabs(%(x)s);\n               x2=%(x)s * %(x)s; \n               %(z)s = %(x)s > 25.0 ? %(x)s -log(%(x)s) : xa<0.1 ? %(x)s/2.0                       +x2/24.0-x2*x2/2880.0 :                        log((exp(%(x)s)-1.0)/%(x)s );\n            }' % locals()
        raise NotImplementedError('only floatingpoint is implemented')


scalar_tedcgf = ScalarTedCGF((scalar.upgrade_to_float), name='scalar_tedcgf')
tedcgf = elemwise.Elemwise(scalar_tedcgf, name='tedcgf')

class ScalarLinAct(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        return x

    def impl(self, x):
        return ScalarLinAct.st_impl(x)

    def grad(self, inp, grads):
        x, = inp
        gz, = grads
        y = 1.0
        return [
         y * gz]


scalar_linact = ScalarLinAct((scalar.upgrade_to_float), name='scalar_linact')
linact = elemwise.Elemwise(scalar_linact, name='linact')
linact_inplace = elemwise.Elemwise((ScalarLinAct(scalar.transfer_type(0))),
  inplace_pattern={0: 0},
  name='linact_inplace')

class ScalarLinActGrad(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        return 1.0

    def impl(self, x):
        return ScalarLinActGrad.st_impl(x)


scalar_linactgrad = ScalarLinActGrad((scalar.upgrade_to_float), name='scalar_linactgrad')
from theano.tensor.nnet.sigm import scalar_sigmoid

class ScalarLexp(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        if x < -14.0:
            return numpy.exp(x)
        if x > 14.0:
            return x
        bet = numpy.exp(x)
        out = numpy.log(1.0 + bet)
        return out

    def impl(self, x):
        return ScalarTed.st_impl(x)

    def grad(self, inp, grads):
        x, = inp
        gz, = grads
        y = scalar_lexpgrad(x)
        return [
         y * gz]

    def c_code(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32:
            return '\n          %(z)s = %(x)s < -12.0f ? exp(%(x)s) :                   %(x)s > 12.0f ? %(x)s  :                    log(1.0f+exp(%(x)s));' % locals()
        if node.inputs[0].type == scalar.float64:
            return '\n          %(z)s = %(x)s < -30.0 ? exp(%(x)s) :                   %(x)s > 30.0 ? %(x)s  :                    log(1.0+exp(%(x)s));' % locals()
        raise NotImplementedError('only floatingpoint is implemented')


scalar_lexp = ScalarLexp((scalar.upgrade_to_float), name='scalar_lexp')
lexp = elemwise.Elemwise(scalar_lexp, name='lexp')
lexp_inplace = elemwise.Elemwise((ScalarLexp(scalar.transfer_type(0))),
  inplace_pattern={0: 0},
  name='lexp_inplace')

class ScalarLexpGrad(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        if x < -14.0:
            return numpy.exp(x)
        if x > 14.0:
            return 1.0
        bet = numpy.exp(x)
        out = bet / (bet + 1)
        return out

    def impl(self, x):
        return ScalarLexpGrad.st_impl(x)

    def c_code(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32:
            return '\n          %(z)s = %(x)s < -12.0f ? exp(%(x)s) :                   %(x)s > 12.0f ? 1.0f  :                    exp(%(x)s)/(1.0f+exp(%(x)s));' % locals()
        if node.inputs[0].type == scalar.float64:
            return '\n          %(z)s = %(x)s < -30.0 ? exp(%(x)s) :                   %(x)s > 30.0 ? 1.0  :                    exp(%(x)s)/(1.0+exp(%(x)s));' % locals()
        raise NotImplementedError('only floatingpoint is implemented')

    def c_code_(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32:
            return '{\n          float bet;           if (%(x)s < -12.0f) {                %(z)s = exp(%(x)s);           } else if (%(x)s > 12.0f) {                %(z)s = 1.0f;           }  else {                bet = exp(%(x)s);                %(z)s = bet/(bet+1.0f);           };} ' % locals()
        if node.inputs[0].type == scalar.float64:
            return '{\n          double bet;           if (%(x)s < -30.0) {                %(z)s = exp(%(x)s);           } else if (%(x)s > 30.0) {                %(z)s = 1.0;           }  else {                bet = exp(%(x)s);                %(z)s = bet/(bet+1.0);           };} ' % locals()
        raise NotImplementedError('only floatingpoint is implemented')

    def c_code__(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32 or node.inputs[0].type == scalar.float16:
            return '{\n               float bet;\n               bet=exp(%(x)s);\n               %(z)s = %(x)s > 12.0f ? 1.0f :  %(x)s < -12.0f ? bet : bet/(bet+1.0f);\n            }' % locals()
        if node.inputs[0].type == scalar.float64:
            return '{\n               double bet;\n               bet=exp(%(x)s);\n               %(z)s = %(x)s > 10.0 ? 1.0 :  %(x)s < -10.0 ? bet : bet/(bet+1.0);\n            }' % locals()
        raise NotImplementedError('only floatingpoint is implemented')


scalar_lexpgrad = ScalarLexpGrad((scalar.upgrade_to_float), name='scalar_lexpgrad')
lexpgrad = elemwise.Elemwise(scalar_lexpgrad, name='lexpgrad')

class ScalarLimAlpha(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        if x > 200:
            return 200
        if x < -200:
            return -200
        if x > -0.001:
            if x < 0.001:
                return 0.001 * T.sgn(x)
        return x

    def impl(self, x, a):
        return ScalarLimAlpha.st_impl(x)

    def c_code(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32:
            return '\n          %(z)s = %(x)s > 200.0f ? 200.0f : %(x)s < -200.0f ? -200.0f :            ((%(x)s > -0.001f) && (%(x)s < 0.001f)) ?             (%(x)s < 0.0f ? -0.001f : 0.001f) :  %(x)s;' % locals()
        if node.inputs[0].type == scalar.float64:
            return '\n          %(z)s = %(x)s > 200.0 ? 200.0 : %(x)s < -200.0 ? -200.0 :            ((%(x)s > -0.001) && (%(x)s < 0.001)) ?             (%(x)s < 0.0 ? -0.001 : 0.001) :  %(x)s;' % locals()
        raise NotImplementedError('only floatingpoint is implemented')


scalar_limalpha = ScalarLimAlpha((scalar.upgrade_to_float), name='scalar_limalpha')
limalpha = elemwise.Elemwise(scalar_limalpha, name='limalpha')

class ScalarTedLca(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        if x > 50.0:
            return numpy.log(x) - x
        if abs(x) < 0.0001:
            x2 = x * x
            return -x / 2.0 * (1.0 + x / 12.0 * (1 - x2 / 120.0 * (1.0 - x2 / 63.0)))
        return -numpy.log((numpy.exp(x) - 1.0) / x)

    def impl(self, x):
        return ScalarTedLca.st_impl(x)

    def grad(self, inp, grads):
        x, = inp
        gz, = grads
        y = -scalar_ted(x)
        return [
         y * gz]

    def c_code(self, node, name, inp, out, sub):
        x, = inp
        z, = out
        if node.inputs[0].type == scalar.float32:
            return '\n          {float x2;          x2=%(x)s*%(x)s;            %(z)s = %(x)s > 50.0f ? log(%(x)s)-%(x)s :                   fabs(%(x)s) < 0.01f ? -%(x)s/2.0f*(1.0f-%(x)s/12.0f*(1.0f-x2/120.0f*(1.0f-x2/63.0f))) :                   log(%(x)s/(exp(%(x)s)-1.0f));}' % locals()
        if node.inputs[0].type == scalar.float64:
            return '\n          { double x2;          x2=%(x)s*%(x)s;           %(z)s = %(x)s > 50.0 ? log(%(x)s)-%(x)s :                   fabs(%(x)s) < 0.01 ? -%(x)s/2.0*(1.0-%(x)s/12.0*(1.0-x2/120.0*(1.0-x2/63.0))) :                   log(%(x)s/(exp(%(x)s)-1.0));}' % locals()
        raise NotImplementedError('only floatingpoint is implemented')


scalar_tedlca = ScalarTedLca((scalar.upgrade_to_float), name='scalar_tedlca')
tedlca = elemwise.Elemwise(scalar_tedlca, name='tedlca')
tedlca_inplace = elemwise.Elemwise((ScalarTedLca(scalar.transfer_type(0))),
  inplace_pattern={0: 0},
  name='tedlca_inplace')

class ScalarTed2(scalar.UnaryScalarOp):

    @staticmethod
    def st_impl(x):
        if x < -30.0:
            u = -1 / x
            x2 = x * x
            du = 1.0 / x2
            ddu = -2.0 / x2 / x
            return (
             u, du, ddu)
        if x > 30.0:
            u = (x - 1) / x
            x2 = x * x
            du = 1.0 / x2
            ddu = -2.0 / x2 / x
            return (
             u, du, ddu)
        if abs(x) < 0.05:
            x2 = x * x
            u = 0.5 + x * (0.08333333333333333 - x * x / 720)
            du = 0.08333333333333333 - x2 * (0.004166666666666667 - x2 * (0.00016534391534391533 - x2 * (5.787037037037037e-06 - x2 / 5322240)))
            ddu = -x / 120.0 + x2 * x / 1512.0
            return (
             u, du, ddu)
        bet = numpy.exp(x)
        x2 = x * x
        bet1 = bet - 1
        u = bet / bet1 - 1 / x
        du = 1 / x2 - bet / bet1 / bet1
        ddu = -2.0 / x2 / x + (bet * bet + bet) / bet1 / bet1 / bet1
        return (
         u, du, ddu)


scalar_ted2 = ScalarTed2((scalar.upgrade_to_float), name='scalar_ted2')
ted2 = elemwise.Elemwise(scalar_ted2, name='ted2')
# okay decompiling TED.pyc
